#!/bin/sh
#

APPPATH=`dirname $0`

AppRunTime=1
RETCODE=1

signal_handler()
{	
	echo -ne "\nError: script interrupted by a signal.\n";
	/dvr/app/usrbin/wgpio w 25 0
	exit 255;
}

dvr_restart()
{
    /dvr/app/unix_socket /record/set=0
  
    /dvr/app/i2ccmd a 78 
    /dvr/app/i2ccmd W aa 6 2 2 1 b5
    sleep 6
    
    reboot 
}

# Setup a trap in case CtrlC is pressed
#trap signal_handler SIGKILL SIGINT SIGHUP SIGQUIT SIGTERM
#trap signal_handler SIGINT

#set base addr 
reg s 0xb0000000

#set RMII1(GE1) as  GPIO ,               24~35   
reg m 0x60 0x01 9  1

#set gpio 25 output 
reg m 0x64c 0x1 1 1 

while :
do
  if [ $RETCODE -eq 5 ];    then
			break;  # exit to shell   
  elif [ $RETCODE -eq 3 ];  then
	dvr_restart
	break
  else
	echo ${AppRunTime} > /tmp/AppRunTimes  
  	/dvr/app/usrbin/wgpio w 25 1	
	usleep 500000
        /dvr/app/usrbin/wgpio w 25 0
	usleep 500000
	/dvr/app/usrbin/wgpio w 25 1
        usleep 100000
	/dvr/app/dvr_app            
	RETCODE=$?        
	/dvr/app/usrbin/wgpio w 25 0
  fi  
        
  echo $RETCODE
  
  if [ ${RETCODE} -ne 3 ] && [ ${RETCODE} -ne 5 ] ; then  
     AppRunTime=`expr ${AppRunTime} + 1`
  	 if [ ${AppRunTime} -gt 3 ]; then
				dvr_restart  	 			
  	 fi
     sleep 5;
  fi
  sleep 2;
done

/dvr/app/usrbin/wgpio w 25 0

  
