var cameraStatus = {};
cameraStatus.recording =  new Array();
cameraStatus.working   =  new Array();
cameraStatus.state     =  new Array();
cameraStatus.retcontrol   = 0;
cameraStatus.retformat   = 0;

var StatusType = {
	"camera":0,
	"video":1,
	"format":2,
	"version":3,
	"upload":4,
	"upgrade":5,
	"download":6
};
var ActionType = {
	"stop":0,
	"start":1
};
cameraStatus.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8
};

cameraStatus.ResponseStrings = ["Success",
                        "Incorrect http method for this resource",
                        "Unsupported return mime-type",
                        "Unsupported attribute encountered for this resource",
                        "Unknown attribute encountered for this resource",
                        "Unknown property encountered for this resource",
                        "Message parsing error",
                        "Database IO error",
                        "An unknown error was encountered"];

cameraStatus.get = function (opt) {
	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
		},
		url: "/cgi-bin/v1/camera/status/"+opt+"?"+Math.random(),
		type: "GET",
		dataType: "xml",
		success: getSuccessHandler,
		error: function(err, textStatus) {
			//handleError("/camera/status", "GET", err, textStatus);
			selfHandleError(opt);
		}
	});

	function selfHandleError (opt) 
	{
       if(opt == StatusType.video)
       {
         for(i=0;i<4;i++)
		 	cameraStatus.state[i] = 0;
	   }
	}
	
	function getSuccessHandler (xml) {
		var cameraNode = $(xml).children("camera");
		
		var res = $(cameraNode).children("res").attr("ul");
		if (res == undefined) {
			//alert("res not set");
			return;
		} else if (parseInt(res) != cameraStatus.ResponseCodes.SUCCESS) {
			//alert("Error: "+cameraStatus.ResponseStrings[parseInt( res )]);
			return;
		}
        
		if(opt == StatusType.camera)
		{		              
			var statusNode = $(cameraNode).children("status");
			
			for(i=0;i<statusNode.length;i++)
	        {
			    var statusVal = $(statusNode[i]).children("recording");
				if (statusVal == undefined || statusVal.attr("ul") == undefined)
				{
					//alert("camera status not received");
					//return;
					cameraStatus.recording[i] = 0;
				}
				else 
				{  
				    //if read socket ok
				    if(statusVal.attr("ul")!="99")
					cameraStatus.recording[i] = parseInt(statusVal.attr("ul"));							
				}

				statusVal = $(statusNode[i]).children("working");
				if (statusVal == undefined || statusVal.attr("ul") == undefined)
				{
					//alert("record status not received");
					//return;

					cameraStatus.working[i] = 0;
				}
				else 
				{
				    //if read socket ok
				    if(statusVal.attr("ul")!="99")
					cameraStatus.working[i] = parseInt(statusVal.attr("ul"));
			    }			
		    }

		    cameraStatus.setValues();
		
		}		
		else if(opt == StatusType.video)
		{		              
			var statusNode = $(cameraNode).children("record_state");
			
			for(i=0;i<statusNode.length;i++)
	        {
			    var statusVal = $(statusNode[i]).children("record");
				if (statusVal == undefined || statusVal.attr("ul") == undefined)
				{
					cameraStatus.state[i] = 0;
				}
				else 
				{
				    //if read socket ok
				    if(statusVal.attr("ul")!="99")
					cameraStatus.state[i] = parseInt(statusVal.attr("ul"));							
				}					
		    }		
		}		
		else if(opt == StatusType.format)
		{		              
			var statusNode = $(cameraNode).children("status");
			

		    var statusVal = $(statusNode).children("formatting");
			if (statusVal == undefined || statusVal.attr("ul") == undefined)
			{				
				return;
			}
			else 
			{
				var val = parseInt(statusVal.attr("ul"));	
				//alert("format return:"+val);
				if(val == 0)
				{
				   if(cameraStatus.retformat++>3)
				   {
					   clearProgress();
					   $("#btnFormat").attr("disabled", false);
					   show_div(0, "progress_div");
					   //$("#spanLoaderMemCard").html(eval('tip_res.'+getCookieLanguage()+'["Format Disk Fail"]'));  
					   //setTimeout(window.location.reload(),5000);
					   cameraStatus.retformat   = 0;
					   alert(eval('tip_res.'+getCookieLanguage()+'["Format Disk Fail"]'));
					   window.location.reload();
				   }
				}
				else if(val < 999999)
				{
				   clearProgress();
				   $("#btnFormat").attr("disabled", false);
				   show_div(0, "progress_div");
				   //$("#spanLoaderMemCard").html(eval('tip_res.'+getCookieLanguage()+'["Format Disk Ok"]'));  				   
				   //setTimeout(window.location.reload(),5000);
				   cameraStatus.retformat   = 0;
				   alert(eval('tip_res.'+getCookieLanguage()+'["Format Disk Ok"]'));
				   window.location.reload();
				}
				else
				   return; 
			}
		
		}		
		else if(opt == StatusType.version)
		{		              
			var statusNode = $(cameraNode).children("status");

			var statusVal = $(statusNode).children("kernel_version");
			if (statusVal == undefined || statusVal.attr("s") == undefined)
			{				
				//return;
			}
			else 
			{
			    //alert(statusVal.attr("s"));
				$("#kernel_version").html(html_entity_decode(statusVal.attr("s")));
			}
			
		    statusVal = $(statusNode).children("app_version");
			if (statusVal == undefined || statusVal.attr("s") == undefined)
			{				
				//return;
			}
			else 
			{
			    //alert(statusVal.attr("s"));
				//$("#app_version").html((html_entity_decode(statusVal.attr("s")).substring(0,26)));
				$("#app_version").html((html_entity_decode(statusVal.attr("s"))));
			}

            statusVal = $(statusNode).children("mcu_version");
			if (statusVal == undefined || statusVal.attr("s") == undefined)
			{				
				//return;
			}
			else 
			{
				$("#mcu_version").html(html_entity_decode(statusVal.attr("s")));
			}

			
			statusVal = $(statusNode).children("web_version");
			if (statusVal != undefined && statusVal.attr("s") != undefined)			
			{
				$("#web_version").html(statusVal.attr("s"));
			}
			
            statusVal = $(statusNode).children("uboot_version");
			if (statusVal != undefined && statusVal.attr("s") != undefined)			
			{
				$("#uboot_version").html(html_entity_decode(statusVal.attr("s")));
			}         
            //$("#web_version").html(version.webversion);
			
			var camVal = $(statusNode).children("camera_version");
			for(i=0;i<camVal.length;i++)
			{
                statusVal = $(camVal[i]).children("version");
				if (statusVal == undefined || statusVal.attr("s") == undefined)
				{				
					//return;
				}
				else 
				{
				    if(statusVal.attr("s").indexOf("OK")>=0)
				    {                      
					   $("#cam_version"+(i+1)).html(eval('tip_res.'+getCookieLanguage()+'["Camera Not Found"]'));
					}
					else
					  $("#cam_version"+(i+1)).html(html_entity_decode(statusVal.attr("s")));
			    }
			}
		}	
		else if(opt == StatusType.upload)
		{		              
			var statusNode = $(cameraNode).children("status");
			

		    var statusVal = $(statusNode).children("upload");
			if (statusVal == undefined || statusVal.attr("s") == undefined)
			{				
				return;
			}
			else 
			{
				var val = statusVal.attr("s");	
				if(val.indexOf("error")>=0)
				{
				   var tips;
				   clearProgress();
				   show_div(0, "progress_div");
                   //if(getCookieLanguage()=="cn")
				   //   tips="ϴļʧ,ѡļ";
			       //else
				   //   tips="Upload file failed,please try again";
				   tips = eval('tip_res.'+getCookieLanguage()+'["Upload File Fail"]');

				   update_show(tips);
				}
				else if(val !="")
				{				   
                   //if(getCookieLanguage()=="cn")
				   //   $("#L2205").html("ϴļɹԵ");
			       //else
			       //   $("#L2205").html("Upload file ok,please waiting for updating");
			       if(val.indexOf("uploaded")>=0)
				   	 $("#L2205").html(eval('tip_res.'+getCookieLanguage()+'["Waiting For Updating"]'));
				   else	
                     $("#L2205").html(eval('tip_res.'+getCookieLanguage()+'["Upload File Ok"]'));
				   doUpdate();
				}				
				
			}
		
		}	
		else if((opt == StatusType.upgrade) && (cameraStatus.retcontrol == 0))
		{		              
			var statusNode = $(cameraNode).children("status");
			

		    var statusVal = $(statusNode).children("upgrade");
			if (statusVal == undefined || statusVal.attr("ul") == undefined)
			{				
				return;
			}
			else 
			{
			    var val = statusVal.attr("ul");	
				if(val>2)
				{
                   //if(getCookieLanguage()=="cn")
				   //   $("#L2205").html("Ե");
			       //else
			       //   $("#L2205").html("Please waiting for updating");
				   $("#L2205").html(eval('tip_res.'+getCookieLanguage()+'["Waiting For Updating"]'));
				}
				else
				{
				    clearProgress();					
					var tips;
					if(val==0)
					{				  
	                   //if(getCookieLanguage()=="cn")
					   //   tips = "ɹ,ˢҳ!";
				       //else
					   //   tips = "Upgrade ok,please refresh the web!";	
					   tips = eval('tip_res.'+getCookieLanguage()+'["Upgrade Ok And Refresh"]');
					}
					else if(val==1)
					{	
					   cameraStatus.retcontrol = 1;
					   
	                   //if(getCookieLanguage()=="cn")
					   //    tips = "ɹ,DvrҪ,50ˢҳ...";
				       //else
					   //    tips = "Upgrade ok,to refresh after 50 seconds for rebooting...";

					   tips = eval('tip_res.'+getCookieLanguage()+'["Upgrade Ok And Reboot"]');
                                     
					   //setTimeout(update_reboot,10000);	
					   setTimeout(update_tips,1200);
					}
					else
					{				  
	                   //if(getCookieLanguage()=="cn")
					   //    tips = "ʧ,Ҫ!";
				       //else
					   //    tips = "Upgrade failed,please try again in need!";
					   tips = eval('tip_res.'+getCookieLanguage()+'["Upgrade Fail"]');
					}
					update_show(tips);
				}
			}
		
		}
		else if(opt == StatusType.download)
		{		              
			var statusNode = $(cameraNode).children("status");
			

		    var statusVal = $(statusNode).children("download");
			if (statusVal == undefined || statusVal.attr("ul") == undefined)
			{				
				return;
			}
			else 
			{
				var val = parseInt(statusVal.attr("ul"));	
				if(val == 0)
				{
				  tips = eval('tip_res.'+getCookieLanguage()+'["No Config File"]');
				  download_show(tips);
				}
				else
				{
				  $("#dl_config").css("display", "");
				}				 
			}
		
		}		
	}
	
};

cameraStatus.put = function(opt,act,cam) 
{
	//var stream = $("#select_stream").val() + 1;
	//alert(stream);
	function serializeXML() {		

		var xml = '<?xml version="1.0"?>';
		xml += '<camera>';		
		xml += '<action>';

        if(act == ActionType.start)
        {
           xml += '<start ul="' + cam + '"/>';
		}
        else
		{
           xml += '<stop ul="' + cam + '"/>';
		}		

		xml += '</action>';
		xml += '</camera>';

		return xml;
	}

	var xml = serializeXML();

	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");			
		},
		url : "/cgi-bin/v1/camera/status/"+opt,
		type : "PUT",
		data : xml,
		dataType : "xml",
		success : putSuccessHandler,
		error : function(err, textStatus) {
			
			handleError("/camera/status/" + opt, "PUT", err, textStatus);
		}
	});

	function putSuccessHandler(result) {		
		
	}
};

cameraStatus.setValues = function() 
{
  var viewmode = getCookieViewMode();
  var idx    = parseInt(viewmode/5,10);
  for(i=1;i<=4;i++)
  {	    
	{
    $("#txt_camera"+i).val( (cameraStatus.working[i-1+idx*4]>0)?(eval('option_res.'+getCookieLanguage()+'["Ok"]')):(eval('option_res.'+getCookieLanguage()+'["Lost"]')));
	$("#txt_status"+i).val( (cameraStatus.recording[i-1+idx*4]>0)?(eval('option_res.'+getCookieLanguage()+'["Recording"]')):(eval('option_res.'+getCookieLanguage()+'["Idle"]')));
	$("#btn_record"+i).val( (cameraStatus.recording[i-1+idx*4]>0)?(eval('button_res.'+getCookieLanguage()+'["Stop"]')):(eval('button_res.'+getCookieLanguage()+'["Start"]')));
    }
  }
  
  $("#btn_record0").val( (cameraStatus.recording[0]>0)?(eval('button_res.'+getCookieLanguage()+'["Stop All"]')):(eval('button_res.'+getCookieLanguage()+'["Start All"]')));
};

