var audio = {};

audio.from = 0;
audio.to = 0;
audio.duration = 0;

audio.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8	
};

audio.ResponseStrings = [ 
		"Success", 
		"Incorrect http method for this resource",
		"Unsupported return mime-type",
		"Unsupported attribute encountered for this resource",
		"Unknown attribute encountered for this resource",
		"Unknown property encountered for this resource",
		"Message parsing error", "Database IO error",
		"An unknown error was encountered"
];

audio.get = function() {
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");	
			$("#L1108").css( {
				visibility : "visible"
			});
		},
		url : "/cgi-bin/v1/encoders/audio"+"?"+Math.random(),		
		type : "GET",
		async : false,
		dataType : "xml",
		success : getSuccessHandler,
		error : function(err, textStatus) {
			handleError("/encoders/audio", "GET", err, textStatus);
		}
	});

	function getSuccessHandler(xml)
	{
		$("#L1108").hide();
		var audioNode = $(xml).children("audio");
		var res = $(audioNode).children("res").attr("ul");
		if (res == undefined) {
			//alert("res not set");
			return;
		} 
		else if (parseInt(res) != audio.ResponseCodes.SUCCESS) 
		{
			//alert("Error: " + audio.ResponseStrings[parseInt(res)]);
			return;
		}       

	
	    var from = $(audioNode).children("from");
		if (from != undefined && from.attr("ul") != undefined)
		{
			audio.from = parseInt(from.attr("ul"),10);
		}
		
		var to = $(audioNode).children("to");
		if (to != undefined && to.attr("ul") != undefined)
		{					
			audio.to = parseInt(to.attr("ul"),10);
		}		

		var duration = $(audioNode).children("duration");
		if (duration != undefined && duration.attr("ul") != undefined)
		{					
			audio.duration = parseInt(duration.attr("ul"),10);
		}	
	}
};

audio.put = function() 
{
	function serializeXML() {
		var hh,mm;

		var xml = '<?xml version="1.0"?>\r\n';
		xml += '<audio>';		
		
        			
        hh = parseInt($("#txt_hour1").val(),10);
		
	    mm = parseInt($("#txt_min1").val(),10);			

        xml += '<from' + ' ul="' + (hh*3600+mm*60) + '"/>';

		hh = parseInt($("#txt_hour2").val(),10);
	    mm = parseInt($("#txt_min2").val(),10);			

        xml += '<to' + ' ul="' + (hh*3600+mm*60) + '"/>';
        	    
		xml += '<duration' + ' ul="' + $("#txt_duration").val() + '"/>';
		
		xml += '</audio>';

		return xml;
	}

	var xml = serializeXML();
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");
			$("#L1108").show();
			$("#button_audio").attr("disabled", true);
			$("#L1108").html(eval('tip_res.'+getCookieLanguage()+'["Settings Updating"]'));
		},
		url : "/cgi-bin/v1/encoders/audio",
		type : "PUT",
		data : xml,
		dataType : "xml",
		success : putSuccessHandler,
		error : function(err, textStatus) {
			$("#button_audio").attr("disabled", false);
			$("#L1108").hide();
			handleError("/encoders/audio", "PUT", err, textStatus);
		}
	});

	function putSuccessHandler(result) {
		$("#button_audio").attr("disabled", false);
		//$("#L1108").show();
		var audioNode = $(result).children("audio");
		var res = $(audioNode).children("res").attr("ul");

		if (res == undefined) {
			//alert("result not set");
			return;
		} 
		else 
		{
			if (parseInt(res) != audio.ResponseCodes.SUCCESS) {
				//alert("Error: " + audio.ResponseStrings[parseInt(res)]);
				return;
			} 
			else 
			{
				$("#L1108").html(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
				//alert(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
			}
		}
	}
};


audio.setValues = function()
{

      $("#txt_hour1").val(parseInt(audio.from/3600,10));			  
      $("#txt_min1").val(parseInt(audio.from%3600/60,10));
	  $("#txt_hour2").val(parseInt(audio.to/3600,10));			  
      $("#txt_min2").val(parseInt(audio.to%3600/60,10)); 
      $("#txt_duration").val(audio.duration);

      $("#button_audio").val(eval('button_res.'+getCookieLanguage()+'["Apply"]'));
      $("#button_help").val(eval('button_res.'+getCookieLanguage()+'["Help Right"]')); 

	  if( audio.from != 0 || audio.to != 0 )
	  {
         $("#check_ars").attr("checked", true);
		 $("#tb_time").show();
	  }
	  else
	  {
         $("#check_ars").attr("checked", false);
		 $("#tb_time").hide();
	  }
};
