var avc = {};
avc.resolutions = new Array();
avc.bitrates = new Array();
avc.framerates = new Array();
avc.lengths = new Array();
avc.modes = new Array();
avc.audios = new Array();
avc.types  = new Array();
avc.des      = 0;
avc.deskey   ='';
avc.channels = 4;
avc.cameras = 4;

avc.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8,
	"INVALID_ENABLE" : 9,
	"INVALID_RESOLUTION" : 10,
	"INVALID_BITRATE" : 11,
	"BITRATE_TOO_HIGH" : 12,
	"BITRATE_TOO_LOW" : 13,
	"INVALID_MAXFRAMERATE" : 14,
	"MAXFRAMERATE_TOO_LOW" : 15,
	"MAXFRAMERATE_TOO_HIGH" : 16,
	"INVALID_PROFILE" : 15,
	"FAILED_TO_CHANGE_BITRATE" : 16,
	"FAILED_TO_CHANGE_MAXFRAMERATE" : 17
};

avc.ResponseStrings = [ "Success", "Incorrect http method for this resource",
		"Unsupported return mime-type",
		"Unsupported attribute encountered for this resource",
		"Unknown attribute encountered for this resource",
		"Unknown property encountered for this resource",
		"Message parsing error", "Database IO error",
		"An unknown error was encountered",
		"Invalid value specified for enable", "Invalid resolution",
		"Invalid value for bitrate", "Bitrate is too high",
		"Bitrate is too low", "Invalid value for max framerate",
		"MaxFramerate is too high", "MaxFramerate is too low",
		"Invalid profile",
		"Failed to change the bitrate. Please check if your streaming is on.",
		"Failed to change the framerate. Please check if your streaming is on." ];

avc.ResolutionInts = {
	"RESOLUTION_QVGA" : 0,
	"RESOLUTION_VGA" : 1,
	"RESOLUTION_HD" : 2,
	"RESOLUTION_FULL_HD" : 3,
	"RESOLUTION_QCIF" : 4,
	"RESOLUTION_NUM" : 6
};

avc.ResolutionStrings = {
	0 : "320x240",
	1 : "640x480",
	2 : "1280x720",
	3 : "1920x1080",
	4 : "240x160",
	5 : "NUM"
};

//avc.resolutions[0] = avc.Resolutions.RESOLUTION_HD;
//avc.resolutions[1] = avc.Resolutions.RESOLUTION_VGA;

avc.MIN_BITRATES = [ 100, 400, 600, 1000, 48];
//avc.MIN_BITRATES = [ 64, 1000, 1000, 64, 64, 64, 200, 200, 64 ]; // * 1000 {QVGA_MIN, VGA_MIN, HD_MIN, FULL_HD_MIN, QCIF_MIN}
avc.MAX_BITRATES = [ 400, 800, 4000, 6000, 200];
//avc.MAX_BITRATES = [ 500, 4000, 500, 500, 500, 1500, 1500, 500 ]; // * 1000 {QVGA_MAX, VGA_MAX, HD_MAX, FULL_HD_MAX, QCIF_MAX}

avc.MIN_FRAMERATES = [ 1, 1, 1, 1, 1]; // {QVGA_MIN, VGA_MIN, HD_MIN, FULL_HD_MIN, QCIF_MIN}
avc.MAX_FRAMERATES = [ 30, 30, 30, 30, 30]; // {QVGA_MAX, VGA_MAX, HD_MAX, FULL_HD_MAX, QCIF_MAX}

avc.get = function(resolution) {
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");
			$("#spanLoaderAvcGet").css( {
				visibility : "visible"
			});
		},
		url : "/cgi-bin/v1/encoders/avc/" + resolution + "?" + Math.random(),
		type : "GET",
		async : false,
		dataType : "xml",
		success : getSuccessHandler,
		error : function(err, textStatus) {
			handleError("/encoders/avc/" + resolution, "GET", err, textStatus);
		}
	});

	function getSuccessHandler(xml) {
		
		var avcsNode = $(xml).children("avc");
		//alert(xml);
		var res = $(avcsNode).children("res").attr("ul");
		if (res == undefined) {
			//alert("res not set");
			return;
		} else if (parseInt(res) != avc.ResponseCodes.SUCCESS) {
			//alert("Error: " + avc.ResponseStrings[parseInt(res)]);
			return;
		}

		var recNode = $(avcsNode).children("record");
        avc.cameras = recNode.length;
		
		for(i=0;i<recNode.length;i++)
	    {
	        var resolutionNode = $(recNode[i]).children("resolution");
			if (resolutionNode == undefined || resolutionNode.attr("s") == undefined) 
			{
				//avc.resolutions[i] = '0';
			} 
			else
			{
				avc.resolutions[i] = resolutionNode.attr("s");				
			}
			
			var bitrateNode = $(recNode[i]).children("bitrate");
			if (bitrateNode == undefined || bitrateNode.attr("ul") == undefined) 
			{
				//alert("bitrate not received");
				return;
			} 
			else
			{
				avc.bitrates[i] = parseInt(bitrateNode.attr("ul")) / 1000;	
			}

			var framerateNode = $(recNode[i]).children("framerate");
			if (framerateNode == undefined || framerateNode.attr("ul") == undefined)
			{
				//alert("framerate not received");
				return;
			}
			else 
			{
				avc.framerates[i] = framerateNode.attr("ul");
			}

	        var lengthNode = $(recNode[i]).children("length");
			if (lengthNode == undefined || lengthNode.attr("ul") == undefined)
			{
				//alert("length not received");
				return;
			}
			else 
			{
				avc.lengths[i] = parseInt(lengthNode.attr("ul"),10)/60;
			}

			var modeNode = $(recNode[i]).children("mode");
			if (modeNode == undefined || modeNode.attr("ul") == undefined)
			{
				//alert("mode not received");
				return;
			}
			else 
			{
				avc.modes[i] = modeNode.attr("ul");
			}

			var audio = $(recNode[i]).children("audio");
			if (audio == undefined || audio.attr("ul") == undefined)
			{
				//alert("audio not received");
				return;
			}
			else 
			{
				avc.audios[i] = audio.attr("ul");
			}

		    if(i == 0)
		    {
	           	var des = $(recNode[i]).children("des");
				if (des != undefined && des.attr("ul") != undefined)
				{			
					avc.des = parseInt(des.attr("ul"));
				}

				des = $(recNode[i]).children("deskey");
				if (des != undefined && des.attr("s") != undefined)				
				{
					avc.deskey = des.attr("s");
				}			
		    }

			var type = $(recNode[i]).children("type");
			if (type != undefined && type.attr("ul") != undefined)			
			{
				avc.types[i] = type.attr("ul");
			}
	    }
	}
};

avc.put = function(stream) 
{
	//var stream = $("#select_stream").val() + 1;
	//alert(stream);
	function serializeXML() {		

		var xml = '<?xml version="1.0"?>';
		xml += '<avc>';		
		xml += '<records>';
		
        var resolution;
		var bitrate;
		var framerate;
		var length;
		var mode;
		var audio;
		
		for(i=1;i<=avc.cameras;i++)
		{
		  if(stream == 0)
		  {
		    if(i<=4)
		    {
			    avc.resolutions[i-1] = $("#txt_resolution"+i).val();
			    avc.bitrates[i-1] = $("#txt_bitrate"+i).val();
			    avc.framerates[i-1] = $("#txt_framerate"+i).val();
			    avc.lengths[i-1] = $("#txt_filelength"+i).val();
			    avc.modes[i-1] = $("#op_recordmode"+i).val();
			    avc.audios[i-1] = $("#op_audio"+i).val();
		    }
	
			{
			    resolution = avc.resolutions[i-1];
			    bitrate = parseInt(avc.bitrates[i-1],10)*1000;
			    framerate = avc.framerates[i-1];
			    length = parseInt(avc.lengths[i-1],10)*60;
			    mode = avc.modes[i-1];
			    audio = avc.audios[i-1];
		    }	
		  }
		  else if(stream == 1)
		  {
		    if(i>4)
		    {
			    avc.resolutions[i-1] = $("#txt_resolution"+(i-4)).val();
			    avc.bitrates[i-1] = $("#txt_bitrate"+(i-4)).val();
			    avc.framerates[i-1] = $("#txt_framerate"+(i-4)).val();
			    avc.lengths[i-1] = $("#txt_filelength"+(i-4)).val();
			    avc.modes[i-1] = $("#op_recordmode"+(i-4)).val();
			    avc.audios[i-1] = $("#op_audio"+(i-4)).val();
		    }
			
			{
			    resolution = avc.resolutions[i-1];
			    bitrate = parseInt(avc.bitrates[i-1],10)*1000;
			    framerate = avc.framerates[i-1];
			    length = parseInt(avc.lengths[i-1],10)*60;
			    mode = avc.modes[i-1];
			    audio = avc.audios[i-1];
		    }	
		  }
		  
		  des = $("#enable_encrypt").attr("checked") ? 1 : 0;
		  
		  xml += '<record resolution="' + resolution + '" bitrate="' + bitrate +'" framerate="' + framerate + '" length="' + length
						+ '" mode="' + mode + '" audio="' + audio + '" des="' + des + '" deskey="' + avc.deskey + '" />';
		}

		xml += '</records>';
		xml += '</avc>';

		return xml;
	}

	var xml = serializeXML();

	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");
			$("#L1020").css( {
				visibility : "visible"
			});
			$("#L1020").html(eval('tip_res.'+getCookieLanguage()+'["Settings Updating"]'));
			$("#button_encoder").attr("disabled", true);
		},
		url : "/cgi-bin/v1/encoders/avc/" + stream,
		type : "PUT",
		data : xml,
		dataType : "xml",
		success : putSuccessHandler,
		error : function(err, textStatus) {
			$("#button_encoder").attr("disabled", false);
			$("#L1020").css( {
				visibility : "hidden"
			});
			handleError("/encoders/avc/" + stream, "PUT", err, textStatus);
		}
	});

	function putSuccessHandler(result) {
		$("#button_encoder").attr("disabled", false);
		//$("#L1020").css( {
		//	visibility : "hidden"
		//});
		var avcNode = $(result).children("avc");
		var res = $(avcNode).children("res").attr("ul");

		if (res == undefined) {
			//alert("result not set");
			return;
		} 
		else 
		{
			if (parseInt(res) != avc.ResponseCodes.SUCCESS) {
				//alert("Error: " + avc.ResponseStrings[parseInt(res)]);
				return;
			} else 
			{
				//alert(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
				$("#L1020").html(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
			}
		}
	}
};

avc.setValues = function(idx) 
{
  for(var i=1;i<=avc.channels;i++)
  {
    
	if(avc.types[i-1+idx*4] == 1 )
	{
	  $("#txt_resolution"+i).val('1920x1080');
	  $("#txt_resolution"+i).attr("disabled", true);
	}
	else
	{
	  $("#txt_resolution"+i).val(avc.resolutions[i-1+idx*4]);
	  $("#txt_resolution"+i).attr("disabled", false);
	} 
	$("#txt_bitrate"+i).val(avc.bitrates[i-1+idx*4]);
	$("#txt_framerate"+i).val(avc.framerates[i-1+idx*4]);
    $("#txt_filelength"+i).val(avc.lengths[i-1+idx*4]);
	$("#op_recordmode"+i).val(avc.modes[i-1+idx*4]);	
	$("#op_audio"+i).val(avc.audios[i-1+idx*4]);
	if( 2 == parseInt($("#op_recordmode"+i).val(),10) )
	{
	  $("#txt_size"+i).val(0);
	  $("#btn_record"+i).attr("disabled",true);
	} 
	else
	{	  
	  if($("#txt_resolution"+i).val() == "1920x1080")
	     $("#txt_size"+i).val(parseInt(avc.bitrates[i-1+idx*4]*45/100*3/4));
	  else
	  	 $("#txt_size"+i).val(parseInt(avc.bitrates[i-1+idx*4]*45/100/2));
	}    
    //$("#txt_camera"+i).val( (avc.cameras[i-1]>0)?"Ok":"Lost" );
	//$("#txt_status"+i).val( (avc.records[i-1]>0)?"Recording":"Idle" );
	//$("#btn_record"+i).val( (avc.records[i-1]>0)?"Stop":"Start" );
  }

  $("#button_encoder").val(eval('button_res.'+getCookieLanguage()+'["Apply"]'));
  $("#button_help").val(eval('button_res.'+getCookieLanguage()+'["Help Right"]'));

  $("#enable_encrypt").attr("checked", avc.des == 1);

  $("#encrypt1").val(avc.deskey);
  $("#encrypt2").val(avc.deskey);
  
  avc.setDiskSize();
  avc.setTotalRecordHours();
};

avc.setResolution = function(i,idx) {
	avc.resolutions[i-1+idx*4]=$("#txt_resolution"+i).val();
	
	var bitrate = $("#txt_bitrate"+i).val();	
	if( 2 == parseInt($("#op_recordmode"+i).val(),10) )
	   $("#txt_size"+i).val(0);
	else if($("#txt_resolution"+i).val() == "1920x1080")
	   $("#txt_size"+i).val(parseInt(bitrate*45/100*3/4));
	else
       $("#txt_size"+i).val(parseInt(bitrate*45/100/2));
	avc.setTotalRecordHours();
};

avc.setSize = function(i,idx) {
	var bitrate = $("#txt_bitrate"+i).val();
	avc.bitrates[i-1+idx*4]=bitrate;
	
	if( 2 == parseInt($("#op_recordmode"+i).val(),10) )
	   $("#txt_size"+i).val(0);
	else if($("#txt_resolution"+i).val() == "1920x1080")
	   $("#txt_size"+i).val(parseInt(bitrate*45/100*3/4));
	else
       $("#txt_size"+i).val(parseInt(bitrate*45/100/2));
	avc.setTotalRecordHours();
};

avc.setFps = function(i,idx) {
	avc.framerates[i-1+idx*4]=$("#txt_framerate"+i).val();		
};

avc.setLength = function(i,idx) {
	avc.lengths[i-1+idx*4]=$("#txt_filelength"+i).val();		
};

avc.setAudio = function(i,idx) {
	avc.audios[i-1+idx*4]=$("#op_audio"+i).val();		
};

avc.setMode = function(i,idx) {	
	var mode = parseInt($("#op_recordmode"+i).val(),10);
	avc.modes[i-1+idx*4]=$("#op_recordmode"+i).val();
		
	if(mode ==2)
	{
		$("#txt_size"+i).val(0);
		$("#btn_record"+i).attr("disabled",true);
	}	
    else
    {   if($("#txt_resolution"+i).val() == "1920x1080")
           $("#txt_size"+i).val(parseInt(avc.bitrates[i-1+idx*4]*45/100*3/4));
	    else
		   $("#txt_size"+i).val(parseInt(avc.bitrates[i-1+idx*4]*45/100/2));
		$("#btn_record"+i).attr("disabled",false);
    }
	avc.setTotalRecordHours();
		
};

avc.setDiskSize = function()
{
   if (memcard.detected == 1) 
   {
     $("#disk_size").html(eval('tip_res.'+getCookieLanguage()+'["Total Memory"]')+memcard.totalmem+eval('tip_res.'+getCookieLanguage()+'["MBytes"]'));     
   }
   else
   {
     $("#disk_size").html(eval('tip_res.'+getCookieLanguage()+'["No Disk"]'));
   }
};
avc.setTotalRecordHours = function()
{
   //$("#record_hours").html(eval('tip_res.'+getCookieLanguage()+'["Total Memory"]')+memcard.totalmem+" Mb");
   if (memcard.detected == 1) 
   {
      var totalSize = 0;
      for(i=1;i<=avc.cameras;i++)
      {
         if(cameraStatus.recording[i-1] >0)	
         {
            if(avc.resolutions[i-1] == "1920x1080")
			   totalSize += parseInt(avc.bitrates[i-1]*45/100*3/4,10);
			else
			   totalSize += parseInt(avc.bitrates[i-1]*45/100/2,10);
         }
           
	  }
	  
	  if(totalSize > 0)          
        $("#record_hours").html(eval('tip_res.'+getCookieLanguage()+'["Total Record Time"]')+parseInt(memcard.totalmem/totalSize,10)+eval('tip_res.'+getCookieLanguage()+'["Hours"]'));
   }
};
