var schedule = {};

schedule.sched = [
	[
	 [0,0],
	 [0,0],
	 [0,0]
	],
	[
	 [0,0],
	 [0,0],
	 [0,0]
	],
	[
	 [0,0],
	 [0,0],
	 [0,0]
	],
	[
	 [0,0],
	 [0,0],
	 [0,0]
	],
	[
	 [0,0],
	 [0,0],
	 [0,0]
	],
	[
	 [0,0],
	 [0,0],
	 [0,0]
	],
	[
	 [0,0],
	 [0,0],
	 [0,0]
	],
	[
	 [0,0],
	 [0,0],
	 [0,0]
	]
];

schedule.cameras = 8;

schedule.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8	
};

schedule.ResponseStrings = [ 
		"Success", 
		"Incorrect http method for this resource",
		"Unsupported return mime-type",
		"Unsupported attribute encountered for this resource",
		"Unknown attribute encountered for this resource",
		"Unknown property encountered for this resource",
		"Message parsing error", "Database IO error",
		"An unknown error was encountered"
];

schedule.currentCam = 0;

schedule.get = function(instance) {
	schedule.currentCam = instance;
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");	
			$("#L1108").css( {
				visibility : "visible"
			});
		},
		//url : "/cgi-bin/v1/encoders/sched"+"?"+Math.random(),
		url : "/cgi-bin/v1/encoders/sched/"+((instance==0)?1:instance)+"?"+Math.random(),
		type : "GET",
		async : false,
		dataType : "xml",
		success : getSuccessHandler,
		error : function(err, textStatus) {
			handleError("/encoders/sched/"+((instance==0)?1:instance), "GET", err, textStatus);
		}
	});

	function getSuccessHandler(xml)
	{
		$("#L1108").hide();
		var scheduleNode = $(xml).children("schedule");
		//alert(xml);
		var res = $(scheduleNode).children("res").attr("ul");
		if (res == undefined) {
			//alert("res not set");
			return;
		} else if (parseInt(res) != schedule.ResponseCodes.SUCCESS) {
			//alert("Error: " + schedule.ResponseStrings[parseInt(res)]);
			return;
		}       

		var i = (schedule.currentCam==0)?0:schedule.currentCam-1;
		var camNode = $(scheduleNode).children("cam");
        //for(var i=0;i<camNode.length;i++)
		{
             var timeNode = $(camNode).children("time");
		     for(var j=0;j<timeNode.length;j++)
		     {
			    //var timeNode = $(camNode).children("time"+(j+1).toString());			  

			    var from = $(timeNode[j]).children("from");
				if (from == undefined || from.attr("ul") == undefined) {
					//alert("field from not received");
					return;
				} else {
					schedule.sched[i][j][0] = parseInt(from.attr("ul"));
				}
				
				var to = $(timeNode[j]).children("to");
				if (to == undefined || to.attr("ul") == undefined) {
					//alert("field to not received");
					return;
				} else {
					schedule.sched[i][j][1] = parseInt(to.attr("ul"));
				}
		     }
	    }
		
		schedule.setCachedValues(schedule.currentCam);
	}
};

schedule.put = function(camch) 
{
	function serializeXML() {
		var hh,mm;

		var xml = '<?xml version="1.0"?>\r\n';
		xml += '<schedule>';		
		
        for(var i=1;i<4;i++)
        {			
            hh = parseInt($("#txt_hour"+i+"1").val(),10);
			
    	    mm = parseInt($("#txt_min"+i+"1").val(),10);			

	        xml += '<from'+ i +' ul="' + (hh*3600+mm*60) + '"/>';

			hh = parseInt($("#txt_hour"+i+"2").val(),10);
    	    mm = parseInt($("#txt_min"+i+"2").val(),10);			

	        xml += '<to'+ i +' ul="' + (hh*3600+mm*60) + '"/>';
        }	    
		
		xml += '</schedule>';

		return xml;
	}

	var xml = serializeXML();
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");
			$("#L1108").show();
			$("#button_schedule").attr("disabled", true);
			$("#L1108").html(eval('tip_res.'+getCookieLanguage()+'["Settings Updating"]'));
		},
		url : "/cgi-bin/v1/encoders/sched/" + camch,//+ "?" + Math.random(),
		//url : "/cgi-bin/v1/encoders/schedule" + "?" + Math.random(),
		type : "PUT",
		data : xml,
		dataType : "xml",
		success : putSuccessHandler,
		error : function(err, textStatus) {
			$("#button_schedule").attr("disabled", false);
			$("#L1108").hide();
			handleError("/encoders/sched/" + camch, "PUT", err, textStatus);
		}
	});

	function putSuccessHandler(result) {
		$("#button_schedule").attr("disabled", false);
		//$("#L1108").show();
		var scheduleNode = $(result).children("schedule");
		var res = $(scheduleNode).children("res").attr("ul");

		if (res == undefined) {
			//alert("result not set");
			return;
		} 
		else 
		{
			if (parseInt(res) != schedule.ResponseCodes.SUCCESS) {
				//alert("Error: " + schedule.ResponseStrings[parseInt(res)]);
				return;
			} else 
			{
			    schedule.getValues(schedule.currentCam);
				$("#L1108").html(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
				//alert(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
			}
		}
	}
};

schedule.getValues = function(cam) {

    var hh,mm;
	
	if (cam <0 || cam > schedule.cameras) return;
    for(var i=1;i<4;i++)
    {
        hh = parseInt($("#txt_hour"+i.toString()+"1").val(),10);
	    mm = parseInt($("#txt_min"+i.toString()+"1").val(),10);			
        if( cam == 0)
        {
            schedule.sched[0][i-1][0] = hh*3600+mm*60;
	        schedule.sched[1][i-1][0] = hh*3600+mm*60;
            schedule.sched[2][i-1][0] = hh*3600+mm*60;
	        schedule.sched[3][i-1][0] = hh*3600+mm*60;
        }
		else
		{
            schedule.sched[cam-1][i-1][0] = hh*3600+mm*60;
		}
		
		hh = parseInt($("#txt_hour"+i.toString()+"2").val(),10);
	    mm = parseInt($("#txt_min"+i.toString()+"2").val(),10);

		if( cam == 0)
		{
			schedule.sched[0][i-1][1] = hh*3600+mm*60;
	        schedule.sched[1][i-1][1] = hh*3600+mm*60;
            schedule.sched[2][i-1][1] = hh*3600+mm*60;
	        schedule.sched[3][i-1][1] = hh*3600+mm*60;
		}
		else
		{
            schedule.sched[cam-1][i-1][1] = hh*3600+mm*60;
		}
    }
	 
};

schedule.setCachedValues = function(cam)
{
	if (cam == 0) cam = 1;
	if (cam <1 || cam > schedule.cameras) return;	
	
	for(var i=1;i<4;i++)
	{
      for(var j=1;j<3;j++)
	  {	     
         $("#txt_hour"+i+j).val(parseInt(schedule.sched[cam-1][i-1][j-1]/3600));			  
         $("#txt_min"+i+j).val(parseInt(schedule.sched[cam-1][i-1][j-1]%3600/60));
	  }  
	}

	//if(getCookieLanguage()=="cn")
    {
	   $("#button_clear").val(eval('button_res.'+getCookieLanguage()+'["Clear"]'));
       $("#button_schedule").val(eval('button_res.'+getCookieLanguage()+'["Apply"]'));
       $("#button_help").val(eval('button_res.'+getCookieLanguage()+'["Help Right"]'));
    }   
};

schedule.setValues = function(cam)
{
	if (cam <0 || cam > schedule.cameras) return;
	if (cam == 0) cam = 1;

	schedule.get(cam);
	
	schedule.setCachedValues(cam);	
	
};

