var gsensor = {};
gsensor.threshold = new Array();
gsensor.offset = new Array();
gsensor.instant = new Array();
gsensor.beep = new Array();
gsensor.record = new Array();
gsensor.osd = new Array();
gsensor.scaler=1024;

var GetGSensorType = {
	"settings":0,
	"instant":1
};

gsensor.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8
};

gsensor.ResponseStrings = [ "Success", 
		"Incorrect http method for this resource",
		"Unsupported return mime-type",
		"Unsupported attribute encountered for this resource",
		"Unknown attribute encountered for this resource",
		"Unknown property encountered for this resource",
		"Message parsing error", 
		"Database IO error",
		"An unknown error was encountered"
		];

gsensor.get = function(opt) {
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");			
		},
		url : "/cgi-bin/v1/networks/gsensor/"+ opt + "?" + Math.random(),
		type : "GET",
		async : false,
		dataType : "xml",
		success : getSuccessHandler,
		error : function(err, textStatus) {
			handleError("/networks/gsensor", "GET", err, textStatus);
		}
	});

	function getSuccessHandler(xml) {
		
		var gsensorsNode = $(xml).children("gsensor");
		//alert(xml);
		var res = $(gsensorsNode).children("res").attr("ul");
		if (res == undefined) 
		{
			//alert("res not set");
			return;
		} 
		else if (parseInt(res) != gsensor.ResponseCodes.SUCCESS)
	    {
			//alert("Error: " + gsensor.ResponseStrings[parseInt(res)]);
			return;
		}

		var axisNode = $(gsensorsNode).children("axis");

		for(i=0;i<axisNode.length;i++)
	    {
	        if(opt == GetGSensorType.settings)
			{
			
				var threshold = $(axisNode[i]).children("threshold");
				if (threshold == undefined || threshold.attr("ul") == undefined) 
				{
					//alert("threshold not received");
					//return;
				} 
				else
				{
					gsensor.threshold[i] = threshold.attr("ul");
				}

				var offset = $(axisNode[i]).children("offset");
				if (offset == undefined || offset.attr("ul") == undefined)
				{
					//alert("offset not received");
					//return;
				}
				else 
				{
					gsensor.offset[i] = offset.attr("ul");
				}

		        var beep = $(axisNode[i]).children("beep");
				if (beep == undefined || beep.attr("ul") == undefined)
				{
					//alert("beep not received");
					//return;
				}
				else 
				{
					gsensor.beep[i] = beep.attr("ul");
				}

				var record = $(axisNode[i]).children("record");
				if (record == undefined || record.attr("s") == undefined)
				{
					//alert("record not received");
					//return;
				}
				else 
				{
					gsensor.record[i] = record.attr("s");
				}

				var osd = $(axisNode[i]).children("osd");
				if (osd == undefined || osd.attr("s") == undefined)
				{
					//alert("osd not received");
					//return;
				}
				else 
				{
					gsensor.osd[i] = osd.attr("s");
				}
	           
		    }
			else if(opt == GetGSensorType.instant)
			{
                var instant = $(axisNode[i]).children("instant");
				if (instant == undefined || instant.attr("ul") == undefined) 
				{
					//alert("instant not received");
					//return;
				} 
				else
				{
					gsensor.instant[i] = instant.attr("ul");
				}
			}
        }
	}
};

gsensor.put = function(opt) 
{
	function serializeXML() {		

		var xml = '<?xml version="1.0"?>';
		xml += '<gsensor>';		
		xml += '<axiss>';

		for(i=1;i<=3;i++)
		{
		  var threshold = parseInt($("#txt_threshold"+i).val()*gsensor.scaler,10);
		  var offset    = parseInt($("#txt_offset"+i).val()*gsensor.scaler,10);
		  var osd       = $("#txt_osd"+i).val();
		  var record    = gsensor.record[i-1];
		  var beep      = $("#op_beep"+i).val();
	
		  xml += '<axis threshold="' + threshold + '" offset="' + offset + '" record="' + record
						+ '" beep="' + beep + '" osd="' + osd + '" />';
		}
		xml += '</axiss>';
		xml += '</gsensor>';

		return xml;
	}

	var xml = serializeXML();

	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");
			$("#L1809").css( {
				visibility : "visible"
			});
			$("#button_gsensor").attr("disabled", true);
			$("#L1809").html(eval('tip_res.'+getCookieLanguage()+'["Settings Updating"]'));
		},
		url : "/cgi-bin/v1/networks/gsensor/"+opt,
		type : "PUT",
		data : xml,
		dataType : "xml",
		success : putSuccessHandler,
		error : function(err, textStatus) {
			$("#button_gsensor").attr("disabled", false);
			$("#L1809").css( {
				visibility : "hidden"
			});
			handleError("/networks/gsensor", "PUT", err, textStatus);
		}
	});

	function putSuccessHandler(result) {
		$("#button_gsensor").attr("disabled", false);
		//$("#L1809").css( {
		//	visibility : "hidden"
		//});
		var gsensorNode = $(result).children("gsensor");
		var res = $(gsensorNode).children("res").attr("ul");

		if (res == undefined) {
			//alert("result not set");
			return;
		} 
		else 
		{
			if (parseInt(res) != gsensor.ResponseCodes.SUCCESS) {
				//alert("Error: " + gsensor.ResponseStrings[parseInt(res)]);
				return;
			} else 
			{
			    $("#L1809").html(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
			}
		}
	}
};

gsensor.setValues = function() 
{
  for(var i=1;i<=3;i++)
  {
	$("#txt_threshold"+i).val(parseInt(gsensor.threshold[i-1]/gsensor.scaler*1000,10)/1000);
	$("#txt_offset"+i).val(parseInt(gsensor.offset[i-1]/gsensor.scaler*1000,10)/1000);
    $("#txt_osd"+i).val(gsensor.osd[i-1]);
	$("#txt_almrecord"+i).val(changeRecordTips(gsensor.record[i-1],16));	
	$("#op_beep"+i).val(gsensor.beep[i-1]);		
  }

  //if(getCookieLanguage()=="cn")
  {
     $("#button_gsensor").val(eval('button_res.'+getCookieLanguage()+'["Apply"]'));
	 $("#button_help").val(eval('button_res.'+getCookieLanguage()+'["Help Right"]'));
  }
};

gsensor.setInstant = function() 
{
  for(var i=1;i<=3;i++)
  {
	$("#txt_instant"+i).val(parseInt(gsensor.instant[i-1]/gsensor.scaler*1000,10)/1000);	
  }
};