var motor = {};
motor.id = "";
motor.speedsource=1;
motor.speedunit=0;
motor.pulse=0;	
motor.threshold=0;
motor.beep=0;
motor.record="0x0";
motor.osd="";
motor.idlethreshold="";

motor.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8	
};

motor.ResponseStrings = [ 
		"Success", 
		"Incorrect http method for this resource",
		"Unsupported return mime-type",
		"Unsupported attribute encountered for this resource",
		"Unknown attribute encountered for this resource",
		"Unknown property encountered for this resource",
		"Message parsing error", "Database IO error",
		"An unknown error was encountered"
];

motor.get = function() {	
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");	
			$("#L1609").css( {
				visibility : "visible"
			});
		},
		url : "/cgi-bin/v1/camera/motor?"+Math.random(),
		type : "GET",
		async : false,
		dataType : "xml",
		success : getSuccessHandler,
		error : function(err, textStatus) {
			handleError("/camera/motor", "GET", err, textStatus);
		}
	});

	function getSuccessHandler(xml)
	{
		$("#L1609").css( {
				visibility : "hidden"
			});
		var motorNode = $(xml).children("motor");
		//alert(xml);
		var res = $(motorNode).children("res").attr("ul");
		if (res == undefined) {
			//alert("res not set");
			return;
		} else if (parseInt(res) != motor.ResponseCodes.SUCCESS) {
			//alert("Error: " + motor.ResponseStrings[parseInt(res)]);
			return;
		}       

		var valNode = $(motorNode).children("id");
		if (valNode == undefined || valNode.attr("s") == undefined)
		{
			//alert("motor level not received");
			//return;
		}
		else 
		{
			motor.id = html_entity_decode(valNode.attr("s"));
		}	        

        valNode = $(motorNode).children("spdsource");
		if (valNode == undefined || valNode.attr("ul") == undefined)
		{
			//alert("motor on hour not received");
			//return;
		}
		else 
		{
			motor.speedsource = parseInt(valNode.attr("ul"));
		}

        valNode = $(motorNode).children("spdunit");
		if (valNode == undefined || valNode.attr("ul") == undefined)
		{
			//alert("motor on hour not received");
			//return;
		}
		else 
		{
			motor.speedunit = parseInt(valNode.attr("ul"));
		}
		
        valNode = $(motorNode).children("threshold");
		if (valNode == undefined || valNode.attr("ul") == undefined)
		{
			//alert("motor on hour not received");
			//return;
		}
		else 
		{
			motor.threshold = parseInt(valNode.attr("ul"),10);
		}

		valNode = $(motorNode).children("pulses");
		if (valNode == undefined || valNode.attr("ul") == undefined)
		{
			//alert("motor on hour not received");
			//return;
		}
		else 
		{
			motor.pulse = parseInt(valNode.attr("ul"),10);
		}

		valNode = $(motorNode).children("beep");
		if (valNode == undefined || valNode.attr("ul") == undefined)
		{
			//alert("motor on hour not received");
			//return;
		}
		else 
		{
			motor.beep = parseInt(valNode.attr("ul"));
		}
		
		valNode = $(motorNode).children("record");
		if (valNode == undefined || valNode.attr("s") == undefined)
		{
			//alert(" acc delay not received");
			//return;
		}
		else 
		{
			motor.record = valNode.attr("s");
		}

		valNode = $(motorNode).children("osd");
		if (valNode == undefined || valNode.attr("s") == undefined)
		{
			//alert(" acc delay not received");
			//return;
		}
		else 
		{
			motor.osd = html_entity_decode(valNode.attr("s"));
		}

		valNode = $(motorNode).children("idlethreshold");
		if (valNode != undefined && valNode.attr("ul") != undefined)		
		{
			motor.idlethreshold = parseInt(valNode.attr("ul"));
		}
	}
};

motor.put = function() 
{
	function serializeXML() {
		       
		var xml = '<?xml version="1.0"?>\r\n';
		xml += '<motor>';	
		
		xml += '<id s="' + $("#motor_id").val() + '"/>';
		xml += '<spdsource ul="' + $("#motor_speedsource").val() + '"/>';
		xml += '<spdunit ul="' + $("#motor_speedunit").val() + '"/>';
		xml += '<threshold ul="' + $("#motor_speed").val() + '"/>';
		//xml += '<pulses ul="' + $("#motor_pulses").val() + '"/>';
		xml += '<beep ul="' + $("#motor_buzzer").val() + '"/>';
		xml += '<record s="' + motor.record + '"/>';
		xml += '<osd s="' + $("#motor_osd").val() + '"/>';
		xml += '<idlethreshold ul="' + $("#motor_idling").val() + '"/>';
		xml += '</motor>';

		return xml;
	}

	var xml = serializeXML();
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");
			$("#L1609").css( {
				visibility : "visible"
			});
			$("#button_motor").attr("disabled", true);
			$("#L1609").html(eval('tip_res.'+getCookieLanguage()+'["Settings Updating"]'));
		},
		url : "/cgi-bin/v1/camera/motor",
		type : "PUT",
		data : xml,
		dataType : "xml",
		success : putSuccessHandler,
		error : function(err, textStatus) {
			$("#button_motor").attr("disabled", false);
			$("#L1609").css( {
				visibility : "hidden"
			});
			handleError("/camera/motor", "PUT", err, textStatus);
		}
	});

	function putSuccessHandler(result) {
		$("#button_motor").attr("disabled", false);
		//$("#L1609").hide();
		var motorNode = $(result).children("motor");
		var res = $(motorNode).children("res").attr("ul");

		if (res == undefined) {
			//alert("result not set");
			return;
		} 
		else 
		{
			if (parseInt(res) != motor.ResponseCodes.SUCCESS) {
				//alert("Error: " + motor.ResponseStrings[parseInt(res)]);
				return;
			} else 
			{
			    $("#L1609").html(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
			}
		}
	}
};

motor.setValues = function()
{
	$("#motor_id").val(motor.id);
    $("#motor_speedsource").val(motor.speedsource);
	$("#motor_speedunit").val(motor.speedunit);
	$("#motor_speed").val(motor.threshold);
    //$("#motor_pulses").val(motor.pulse);
	$("#motor_buzzer").val(motor.beep);
    //$("#motor_record").val(motor.record);
    $("#motor_record").val(changeRecordTips(parseInt(motor.record,16)));
	$("#motor_osd").val(motor.osd);
	$("#motor_idling").val(motor.idlethreshold);

	//if(getCookieLanguage()=="cn")
    {
       $("#button_motor").val(eval('button_res.'+getCookieLanguage()+'["Apply"]'));
	   $("#button_help").val(eval('button_res.'+getCookieLanguage()+'["Help Right"]'));
    } 
};

