/**
 * @author sudhish
 */
var ethernetsettings = {};

ethernetsettings.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8,
	"ETHERNET_NOT_SUPPORTED" : 9
};

ethernetsettings.ResponseStrings = ["Success",
                                "Incorrect http method for this resource",
                                "Unsupported return mime-type",
                                "Unsupported attribute encountered for this resource",
                                "Unknown attribute encountered for this resource",
                                "Unknown property encountered for this resource",
                                "Message parsing error",
                                "Database IO error",
                                "An unknown error was encountered",
                                "Ethernet not Supported"];


/**
 * @brief Performs a PUT on the /networks/ethernet resource
 */
ethernetsettings.put = function() {
	function serializeXML() {		
		var xml = '<?xml version="1.0"?>';
		xml += '<networks>';
		xml += '<ethernet>';
		xml += '<enable b="1"/>';
		xml += '</ethernet>';
		xml += '</networks>';
		return xml;
	};

	var xml = serializeXML();

	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
			xhrObj.setRequestHeader("Content-Type","application/xml");

			$("#button_ethernet_settings_update").attr("disabled",true);
			$("#L1912").show();
		},
		url: "/cgi-bin/v1/networks/ethernet",
		type: "PUT",
		data: xml,
		dataType: "xml",
		success: putSuccessHandler,
		error: function(err, textStatus) {
			$("#button_ethernet_settings_update").attr("disabled",false);
			$("#L1912").hide();
			handleError("/networks/ethernet", "PUT", err, textStatus);
		}
	});

	function putSuccessHandler( xml ) {
		$("#button_ethernet_settings_update").attr("disabled",false);
		$("#L1912").hide();

		var networksNode = $(xml).children("networks");
		var resultNode = $(networksNode).children("res");

		if ( resultNode.attr("ul") == undefined ) {
			//alert("XML Error: No result node");
			return;
		}

		if( parseInt( resultNode.attr("ul") ) != ethernetsettings.ResponseCodes.SUCCESS ) {
			//alert("Error: "+ethernetsettings.ResponseStrings[parseInt( resultNode.attr("ul") )]);
		} 
	}
};
