var g3 = {};
g3.status = 0;
g3.sim = 99;
g3.enalbe = 0;
g3.dial="*99#";
g3.apn="";
g3.user="";
g3.pass="";
g3.imei="";
g3.netconn = 0;
g3.model = "";

var GetG3Type = {
	"settings":0,
	"status":1
};

g3.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8	
};

g3.ResponseStrings = [ 
		"Success", 
		"Incorrect http method for this resource",
		"Unsupported return mime-type",
		"Unsupported attribute encountered for this resource",
		"Unknown attribute encountered for this resource",
		"Unknown property encountered for this resource",
		"Message parsing error", "Database IO error",
		"An unknown error was encountered"
];

g3.get = function(opt) {	
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");				
		},
		url : "/cgi-bin/v1/networks/g3/"+ opt + "?" + Math.random(),
		type : "GET",
		async : false,
		dataType : "xml",
		success : getSuccessHandler,
		error : function(err, textStatus) {
			handleError("/networks/g3", "GET", err, textStatus);
		}
	});

	function getSuccessHandler(xml)
	{		
		var g3Node = $(xml).children("g3");
		//alert(xml);
		var res = $(g3Node).children("res").attr("ul");
		if (res == undefined) {
			//alert("res not set");
			return;
		} else if (parseInt(res) != g3.ResponseCodes.SUCCESS) {
			//alert("Error: " + g3.ResponseStrings[parseInt(res)]);
			return;
		}       

		if(opt == GetG3Type.status)
		{
	        var valNode = $(g3Node).children("status");
			if (valNode != undefined && valNode.attr("ul") != undefined)			
			{
				g3.status = valNode.attr("ul");
			}
			valNode = $(g3Node).children("netconn");
			if (valNode != undefined && valNode.attr("ul") != undefined)			
			{
				g3.netconn = parseInt(valNode.attr("ul"),10);
			}
			valNode = $(g3Node).children("sim");
			if (valNode != undefined && valNode.attr("ul") != undefined)			
			{
				g3.sim = parseInt(valNode.attr("ul"),10);
			}

			valNode = $(g3Node).children("imei");
			if (valNode != undefined && valNode.attr("s") != undefined)			 
			{
				g3.imei = valNode.attr("s");
			}
			valNode = $(g3Node).children("model");
			if (valNode != undefined && valNode.attr("s") != undefined)			 
			{
				g3.model = valNode.attr("s");
			}
		}		 
		else
		{
			var valNode = $(g3Node).children("enable");
			if (valNode == undefined || valNode.attr("ul") == undefined)
			{
				//alert("g3 level not received");
				//return;
			}
			else 
			{
				g3.enable = valNode.attr("ul");
			}
			
	        valNode = $(g3Node).children("dial");
			if (valNode == undefined || valNode.attr("s") == undefined)
			{
				//alert(" acc delay not received");
				//return;
			}
			else 
			{
				g3.dial = html_entity_decode(valNode.attr("s"));
			}

	        valNode = $(g3Node).children("apn");
			if (valNode == undefined || valNode.attr("s") == undefined)
			{
				//alert(" acc delay not received");
				//return;
			}
			else 
			{
				g3.apn = html_entity_decode(valNode.attr("s"));
			}

			valNode = $(g3Node).children("user");
			if (valNode == undefined || valNode.attr("s") == undefined)
			{
				//alert(" acc delay not received");
				//return;
			}
			else 
			{
				g3.user = html_entity_decode(valNode.attr("s"));
			}

			valNode = $(g3Node).children("pass");
			if (valNode == undefined || valNode.attr("s") == undefined)
			{
				//alert(" acc delay not received");
				//return;
			}
			else 
			{
				g3.pass = html_entity_decode(valNode.attr("s"));
			}
			
		}
	}
};

g3.put = function(opt,index) 
{
	function serializeXML() {
		       
		var xml = '<?xml version="1.0"?>\r\n';
		xml += '<g3>';	
		
		xml += '<enable ul="' + ($("#enable_3g").attr("checked") ? 1 : 0) + '"/>';
		xml += '<dial s="' + $("#txt_dial").val() + '"/>';
		xml += '<apn s="' + $("#txt_apn").val() + '"/>';
		xml += '<user s="' + $("#txt_user").val() + '"/>';
		xml += '<pass s="' + $("#txt_pass").val() + '"/>';
						
		xml += '</g3>';

		return xml;
	}

	var xml = serializeXML();
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");
			$("#L2006").css( {
				visibility : "visible"
			});
			$("#button_3g").attr("disabled", true);
			$("#L2006").html(eval('tip_res.'+getCookieLanguage()+'["Settings Updating"]'));

		},
		url : "/cgi-bin/v1/networks/g3/"+opt,
		type : "PUT",
		data : xml,
		dataType : "xml",
		success : putSuccessHandler,
		error : function(err, textStatus) {
			$("#button_3g").attr("disabled", false);
			$("#L2006").css( {
				visibility : "hidden"
			});
			handleError("/system/g3", "PUT", err, textStatus);
		}
	});

	function putSuccessHandler(result) {
		$("#button_3g").attr("disabled", false);
		//$("#L2006").css( {
		//	visibility : "hidden"
		//});
		var g3Node = $(result).children("g3");
		var res = $(g3Node).children("res").attr("ul");

		if (res == undefined) {
			//alert("result not set");
			return;
		} 
		else 
		{
			if (parseInt(res) != g3.ResponseCodes.SUCCESS) {
				//alert("Error: " + g3.ResponseStrings[parseInt(res)]);
				return;
			} else 
			{
			   $("#L2006").html(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
			}
		}
	}
};

g3.setValues = function(idx)
{	
    $("#enable_3g").attr("checked", g3.enable==1);
    $("#txt_dial").val(g3.dial);
	$("#txt_apn").val(g3.apn);
	$("#txt_user").val(g3.user);	
	$("#txt_pass").val(g3.pass);
	
	//if(getCookieLanguage()=="cn")
    {
       $("#button_3g").val(eval('button_res.'+getCookieLanguage()+'["Apply"]'));
	   $("#button_help").val(eval('button_res.'+getCookieLanguage()+'["Help Right"]'));
    } 
};

g3.setStatus = function()
{	
    $("#op_netconn").val(g3.netconn);
	$("#op_status").val(g3.status);
	if(g3.status == '0')
	{
	   $("#id_imei").css("display", "none");
	   $("#id_model").css("display", "none");
	}   
	else
	{
	   $("#id_imei").css("display", "");
	   $("#id_model").css("display", "");
	   $("#txt_imei").val(g3.imei);
	   $("#txt_model").val(g3.model);
	}   
	if(g3.sim == 99)
	{
	   $("#txt_sim").val(eval('tip_res.'+getCookieLanguage()+'["SIM Checking"]'));
	   $("#id_signal").css("display", "none");
	}	
    else if(g3.sim == 88 || g3.sim == 66)
	{
	   $("#txt_sim").val(eval('tip_res.'+getCookieLanguage()+'["NO SIM"]'));
	   $("#id_signal").css("display", "none");
    } 
	else if(g3.sim == 77)
	{
	   $("#txt_sim").val(eval('tip_res.'+getCookieLanguage()+'["SIM Locked"]'));
	   $("#id_signal").css("display", "none");
    } 
	else 
	{
       $("#txt_sim").val(eval('tip_res.'+getCookieLanguage()+'["SIM Found"]'));  
	   $("#id_signal").css("display", "");
	   $("#txt_signal").val(parseInt(g3.sim*100/32,10).toString()+"%");
	}
}	