var network = {};
network.resolutions = new Array();
network.bitrates = new Array();
network.framerates = new Array();
network.netconn = 0;
network.serverconn = 0;
network.rsvid="";
network.id="";
network.server="ezview.3322.org";
network.port=6608;
network.userid="";
network.userserver="";
network.userport=0;
network.userserverconn = 0;
network.channels = 4;
network.cameras = 4;

var GetNetworkType = {
	"settings":0,
	"status":1
};

network.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8	
};

network.ResponseStrings = [ 
		"Success", 
		"Incorrect http method for this resource",
		"Unsupported return mime-type",
		"Unsupported attribute encountered for this resource",
		"Unknown attribute encountered for this resource",
		"Unknown property encountered for this resource",
		"Message parsing error", "Database IO error",
		"An unknown error was encountered"
];

network.get = function(opt) {	
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");				
		},
		url : "/cgi-bin/v1/networks/network/"+ opt + "?" + Math.random(),
		type : "GET",
		async : false,
		dataType : "xml",
		success : getSuccessHandler,
		error : function(err, textStatus) {
			handleError("/networks/network", "GET", err, textStatus);
		}
	});

	function getSuccessHandler(xml)
	{		
		var networkNode = $(xml).children("network");
		//alert(xml);
		var res = $(networkNode).children("res").attr("ul");
		if (res == undefined) {
			//alert("res not set");
			return;
		} else if (parseInt(res) != network.ResponseCodes.SUCCESS) {
			//alert("Error: " + network.ResponseStrings[parseInt(res)]);
			return;
		}       

		if(opt == GetNetworkType.status)
		{	        			
			var valNode = $(networkNode).children("netconn");
			if (valNode != undefined && valNode.attr("ul") != undefined)			
			{
				network.netconn = valNode.attr("ul");
			}
			valNode = $(networkNode).children("serverconn");
			if (valNode != undefined && valNode.attr("ul") != undefined)			
			{
				network.serverconn = valNode.attr("ul");
			}
			valNode = $(networkNode).children("userserverconn");
			if (valNode != undefined && valNode.attr("ul") != undefined)			
			{
				network.userserverconn = valNode.attr("ul");
			}
		}
		else
		{			
            valNode = $(networkNode).children("rsvid");
			if (valNode != undefined && valNode.attr("s") != undefined)			
			{
				network.rsvid = valNode.attr("s");
			}
			
			valNode = $(networkNode).children("id");
			if (valNode != undefined && valNode.attr("s") != undefined)			
			{
				network.id = valNode.attr("s");
			}

			valNode = $(networkNode).children("server");
			if (valNode != undefined && valNode.attr("s") != undefined)		
			{
				network.server = valNode.attr("s");
			}

			valNode = $(networkNode).children("port");
			if (valNode != undefined && valNode.attr("ul") != undefined)			
			{
				network.port = valNode.attr("ul");
			}

            valNode = $(networkNode).children("userid");
			if (valNode != undefined && valNode.attr("s") != undefined)			
			{
				network.userid = valNode.attr("s");
			}

			valNode = $(networkNode).children("userserver");
			if (valNode != undefined && valNode.attr("s") != undefined)		
			{
				network.userserver = valNode.attr("s");
			}

			valNode = $(networkNode).children("userport");
			if (valNode != undefined && valNode.attr("ul") != undefined)			
			{
				network.userport = valNode.attr("ul");
			}
			
			var streamNode = $(networkNode).children("stream");
			network.cameras = streamNode.length;

			for(i=0;i<streamNode.length;i++)
		    {
		        var resolutionNode = $(streamNode[i]).children("resolution");
				if (resolutionNode == undefined || resolutionNode.attr("s") == undefined) 
				{
					//avc.resolutions[i] = '0';
				} 
				else
				{
					network.resolutions[i] = resolutionNode.attr("s");				
				}
				
				var bitrateNode = $(streamNode[i]).children("bitrate");
				if (bitrateNode == undefined || bitrateNode.attr("ul") == undefined) 
				{
					//alert("bitrate not received");
					return;
				} 
				else
				{
					network.bitrates[i] = parseInt(bitrateNode.attr("ul"),10) / 1000;	
				}

				var framerateNode = $(streamNode[i]).children("framerate");
				if (framerateNode == undefined || framerateNode.attr("ul") == undefined)
				{
					//alert("framerate not received");
					return;
				}
				else 
				{
					network.framerates[i] = framerateNode.attr("ul");
				}
			}	
		}
	}
};

network.put = function(opt,index) 
{
	function serializeXML() {
		       
		var xml = '<?xml version="1.0"?>\r\n';
		xml += '<network>';			
		
		xml += '<id s="' + $("#txt_g3id").val() + '"/>';
		xml += '<server s="' + $("#txt_g3server").val() + '"/>';
		xml += '<port ul="' + $("#txt_g3port").val() + '"/>';

		xml += '<userid s="' + $("#txt_userid").val() + '"/>';
		xml += '<userserver s="' + $("#txt_userserver").val() + '"/>';
		xml += '<userport ul="' + $("#txt_userport").val() + '"/>';
		
		xml += '<streams>';

        for(i=1;i<=network.cameras;i++)
		{
		  if(index == 0)
		  {
		    if(i<=4)
		    {
			    network.resolutions[i-1] = $("#txt_resolution"+i).val();
			    network.bitrates[i-1] = $("#txt_bitrate"+i).val();
			    network.framerates[i-1] = $("#txt_framerate"+i).val();			   
		    }
	
			{
			    resolution = network.resolutions[i-1];
			    bitrate = parseInt(network.bitrates[i-1],10)*1000;
			    framerate = network.framerates[i-1];
			    
		    }	
		  }
		  else if(index == 1)
		  {
		    if(i>4)
		    {
			    network.resolutions[i-1] = $("#txt_resolution"+(i-4)).val();
			    network.bitrates[i-1] = $("#txt_bitrate"+(i-4)).val();
			    network.framerates[i-1] = $("#txt_framerate"+(i-4)).val();			    
		    }
			
			{
			    resolution = network.resolutions[i-1];
			    bitrate = parseInt(network.bitrates[i-1],10)*1000;
			    framerate = network.framerates[i-1];			   
		    }	
		  }

		  xml += '<stream resolution="' + resolution + '" bitrate="' + bitrate +'" framerate="' + framerate + '" />';
        }
				
		xml += '</streams>';
		
		xml += '</network>';

		return xml;
	}

	var xml = serializeXML();
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");
			$("#L2016").css( {
				visibility : "visible"
			});
			$("#button_apply").attr("disabled", true);
			$("#L2016").html(eval('tip_res.'+getCookieLanguage()+'["Settings Updating"]'));

		},
		url : "/cgi-bin/v1/networks/network/"+opt,
		type : "PUT",
		data : xml,
		dataType : "xml",
		success : putSuccessHandler,
		error : function(err, textStatus) {
			$("#button_apply").attr("disabled", false);
			$("#L2016").css( {
				visibility : "hidden"
			});
			handleError("/system/g3", "PUT", err, textStatus);
		}
	});

	function putSuccessHandler(result) {
		$("#button_apply").attr("disabled", false);
		//$("#L2016").css( {
		//	visibility : "hidden"
		//});
		var networkNode = $(result).children("network");
		var res = $(networkNode).children("res").attr("ul");

	    if (res !== undefined)
		{
			if (parseInt(res) != network.ResponseCodes.SUCCESS) {
				//alert("Error: " + network.ResponseStrings[parseInt(res)]);
				return;
			} else 
			{
			   $("#L2016").html(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
			}
		}
	}
};

network.setValues = function(idx)
{	
	$("#txt_g3id").val(network.id);
	$("#txt_g3id").attr("disabled", network.rsvid!="");
	$("#txt_g3server").val(network.server);
    $("#txt_g3port").val(network.port);

	$("#txt_userid").val(network.userid);
	$("#txt_userserver").val(network.userserver);
	if(network.userport != '0')
      $("#txt_userport").val(network.userport);
	
	for(var i=1;i<=network.channels;i++)
    {
	    $("#txt_resolution"+i).val(network.resolutions[i-1+idx*4]);
		$("#txt_bitrate"+i).val(network.bitrates[i-1+idx*4]);
		$("#txt_framerate"+i).val(network.framerates[i-1+idx*4]);
	}
	//if(getCookieLanguage()=="cn")
    {
       $("#button_apply").val(eval('button_res.'+getCookieLanguage()+'["Apply"]'));
	   $("#button_help").val(eval('button_res.'+getCookieLanguage()+'["Help Right"]'));
    } 
};

network.setStatus = function()
{	
	$("#op_netconn").val(network.netconn);
	$("#op_serverconn").val(network.serverconn);
	$("#op_userserverconn").val(network.userserverconn);
}	