var wifisettings = {};
wifisettings.ap_mac = '';
wifisettings.ap_ssid = '';
wifisettings.ap_channel='0';
wifisettings.ap_security = 'NONE';
wifisettings.ap_password = '';
wifisettings.countryregion = '0';
wifisettings.wifi_enable = 1;
wifisettings.hide_ssid = 0;
wifisettings.dhcp_enable = 1;
wifisettings.cli_available = 0;
wifisettings.cli_mode = 3;
wifisettings.cli_ipmode = 1;
wifisettings.cli_ssid = '';
wifisettings.cli_security = 0;
wifisettings.cli_ipaddress = '';
wifisettings.cli_netmask = '';
wifisettings.cli_gateway = '';

wifisettings.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8,
	"INVALID_COUNTRY_REGION" : 9,
	"UNSUPPORTED_COUNTRY_REGION" : 10,
	"FAILED_TO_SET_COUNTRY_REGION" : 11
};

wifisettings.ResponseStrings = ["Success",
                                "Incorrect http method for this resource",
                                "Unsupported return mime-type",
                                "Unsupported attribute encountered for this resource",
                                "Unknown attribute encountered for this resource",
                                "Unknown property encountered for this resource",
                                "Message parsing error",
                                "Database IO error",
                                "An unknown error was encountered",
                                "Invalid country region",
                                "Specified country region is unsupported",
                                "Failed to update the country region"];

wifisettings.wifisettingsSecurityEncryption = [
	"OPEN_NONE",
	"WEP_SHARED",
	"WPAPSK_TKIP",
	"WPAPSK2_TKIP",
	"WPAPSK_AES",
	"WPAPSK2_AES",
	"WPANYONE_TKIP_ADHOC",
	"WPANYONE_AES_ADHOC",
	"WPAENT_AES",
	"WPAENT2_AES",
	"WPAENT_TKIP",
	"WPAENT2_TKIP"];
/**
 * @brief Performs a GET on the /networks/wifi/settings resource
 */
wifisettings.get = function() {
	$.ajax({
		beforeSend: function(xhrObj){
		    xhrObj.setRequestHeader("Accept","application/xml");
		},
		url: "/cgi-bin/v1/networks/wifi/settings?"+Math.random(),
		type: "GET",
		async: false,
		dataType: "xml",
		success: onResponse,
		error: function(XMLHttpRequest, textStatus, errorThrown) {
			handleError("/networks/wifi/settings", "GET", XMLHttpRequest, textStatus);
		}
	});
	
	function onResponse(xml) {
		var networksNode = $(xml).children("networks");
		var resultNode = $(networksNode).children("res");
		
		if ( resultNode.attr("ul") == undefined ) {
			//alert("XML Error: No result node");
			return;
		}

		if( parseInt(resultNode.attr("ul")) != wifisettings.ResponseCodes.SUCCESS ) {
			//alert("Error: "+wifisettings.ResponseStrings[parseInt( resultNode.attr("ul") )]);
			return;
		}
		
		var wifiNode = $(networksNode).children("wifi");
		var settingsNode = $(wifiNode).children("settings");
		
		var ap = $(settingsNode).children("wifi_enable");
		if (ap != undefined && ap.attr("ul") != undefined) 
		{
			wifisettings.wifi_enable = parseInt(ap.attr("ul"));
		}

		ap = $(settingsNode).children("hide_ssid");
		if (ap != undefined && ap.attr("ul") != undefined) 
		{
			wifisettings.hide_ssid = ap.attr("ul");
		}

		ap = $(settingsNode).children("dhcp_enable");
		if (ap != undefined && ap.attr("ul") != undefined) 
		{
			wifisettings.dhcp_enable = ap.attr("ul");
		}
		
		ap = $(settingsNode).children("countryregion");
		if (ap != undefined && ap.attr("ul") != undefined) 
		{
			wifisettings.countryregion = ap.attr("ul");
		}

		ap = $(settingsNode).children("ap_mac");
		if (ap != undefined && ap.attr("s") != undefined) 
		{
			wifisettings.ap_mac =  html_entity_decode(ap.attr("s"));			
		}
		
		ap = $(settingsNode).children("ap_ssid");
		if (ap != undefined && ap.attr("s") != undefined) 
		{
			wifisettings.ap_ssid =  html_entity_decode(ap.attr("s"));			
		}

		ap = $(settingsNode).children("ap_channel");
		if (ap != undefined && ap.attr("ul") != undefined) 
		{
			wifisettings.ap_channel = ap.attr("ul");			
		}

		ap = $(settingsNode).children("ap_security");
		if (ap != undefined && ap.attr("s") != undefined) 
		{
			wifisettings.ap_security = ap.attr("s");
		}

		ap = $(settingsNode).children("ap_password");
		if (ap != undefined && ap.attr("s") != undefined) 
		{
			wifisettings.ap_password = ap.attr("s");
		}

		//client
		var cli = $(settingsNode).children("cli_available");
		if (cli != undefined && cli.attr("ul") != undefined) 
		{
			wifisettings.cli_available = parseInt(cli.attr("ul"));
		}

	    cli = $(settingsNode).children("cli_mode");
		if (cli != undefined && cli.attr("ul") != undefined) 
		{
			wifisettings.cli_mode = parseInt(cli.attr("ul"));
		}

        cli = $(settingsNode).children("cli_ssid");
		if (cli != undefined && cli.attr("s") != undefined) 
		{
			wifisettings.cli_ssid =  html_entity_decode(cli.attr("s"));
		}

		cli = $(settingsNode).children("cli_security");
		if (cli != undefined && cli.attr("ul") != undefined) 
		{
			wifisettings.cli_security = parseInt(cli.attr("ul"));			
		}
		
		cli = $(settingsNode).children("cli_ipmode");
		if (cli != undefined && cli.attr("ul") != undefined) 
		{
			wifisettings.cli_ipmode = parseInt(cli.attr("ul"));
		}

        if(wifisettings.cli_ipmode == 0)
        {
			cli = $(settingsNode).children("cli_ipaddress");
			if (cli != undefined && cli.attr("s") != undefined) 
			{
				wifisettings.cli_ipaddress = html_entity_decode(cli.attr("s"));
			}
			
			cli = $(settingsNode).children("cli_netmask");
			if (cli != undefined && cli.attr("s") != undefined) 
			{
				wifisettings.cli_netmask = html_entity_decode(cli.attr("s"));
			}
			
			cli = $(settingsNode).children("cli_gateway");
			if (cli != undefined && cli.attr("s") != undefined) 
			{
				wifisettings.cli_gateway = html_entity_decode(cli.attr("s"));
			}
        }
	}
};

/**
 * @brief Performs a PUT on the /networks/wifi/settings resource
 */
wifisettings.put = function() {
	function serializeXML() {
				
		var countryregion = $("#select_country_region").val();

		var xml = '<?xml version="1.0"?>';
		xml += '<networks>';
		xml += '<wifi>';
		xml += '<settings>';
		xml += '<wifi_enable ul="'+wifisettings.wifi_enable+'"/>';
		xml += '<dhcp_enable ul="'+wifisettings.dhcp_enable+'"/>';
		xml += '<hide_ssid ul="'+wifisettings.hide_ssid+'"/>';
		xml += '<ap_ssid s="'+$("#ap_ssid").val()+'"/>';
		xml += '<ap_channel ul="'+$("#ap_channel").val()+'"/>';
		xml += '<ap_security s="'+$("#op_security").val()+'"/>';
		xml += '<ap_password s="'+$("#ap_password").val()+'"/>';
		xml += '<countryregion ul="'+countryregion+'"/>';
		xml += '<cli_ipmode ul="' + $("#op_ipmode").val() + '"/>';
		xml += '<cli_ipaddress s="' + wifisettings.cli_ipaddress + '"/>';
		xml += '<cli_netmask s="' + wifisettings.cli_netmask +'"/>';
		xml += '<cli_gateway s="' + wifisettings.cli_gateway +'"/>';
		xml += '</settings>';
		xml += '</wifi>';
		xml += '</networks>';
		return xml;
	};

	var xml = serializeXML();

	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
			xhrObj.setRequestHeader("Content-Type","application/xml");

			$("#button_wifi_settings_update").attr("disabled",true);
			$("#L1912").show();
			$("#L1912").html(eval('tip_res.'+getCookieLanguage()+'["Settings Updating"]'));
		},
		url: "/cgi-bin/v1/networks/wifi/settings",
		type: "PUT",
		data: xml,
		dataType: "xml",
		success: putSuccessHandler,
		error: function(err, textStatus) {
			$("#button_wifi_settings_update").attr("disabled",false);
			$("#L1912").hide();
			handleError("/networks/wifi/settings", "PUT", err, textStatus);
		}
	});

	function putSuccessHandler( xml ) {
		$("#button_wifi_settings_update").attr("disabled",false);
		//$("#L1912").hide();

		var networksNode = $(xml).children("networks");
		var resultNode = $(networksNode).children("res");

		if ( resultNode.attr("ul") == undefined ) {
			//alert("XML Error: No result node");
			return;
		}

		if( parseInt( resultNode.attr("ul") ) != wifisettings.ResponseCodes.SUCCESS ) {
			//alert("Error: "+wifisettings.ResponseStrings[parseInt( resultNode.attr("ul") )]);
		}
		else 
		{
		   $("#L1912").html(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
		}
	}
};

wifisettings.getSecurityTips = function (securityIdx,encryptionIdx) 
{
    security = "";
	encryption = "";
	
	switch(securityIdx)
	{
		case wifiSecurity.OPEN:
			security = "OPEN";			
			break;

		case wifiSecurity.WEP:
			security = "WEP";
			break;

		case wifiSecurity.WPAPSK:
			security = "WPAPSK";
			break;

		case wifiSecurity.WPAPSK2:
			security = "WPAPSK2";
			break;

		case wifiSecurity.WPANYONE:
			security = "WPANYONE";
			break;

		case wifiSecurity.WPAENT:
			security = "WPAENT";
			break;

		case wifiSecurity.WPAENT2:
			security = "WPAENT2";
			break;
	}
	
	switch(encryptionIdx)
	{
		case wifiEncryption.TKIP:
			encryption = "_TKIP";
			break;

		case wifiEncryption.AES:
			encryption = "_AES";
			break;

		default:
			encryption = "";
			break;
	}

	return (security + encryption);
}

wifisettings.setValues = function () 
{   
    $("#enable_wifi_ap").attr("checked", (wifisettings.wifi_enable&0x1) == 1);
	$("#enable_wifi_client").attr("checked", (wifisettings.wifi_enable&0x2) == 2);
	$("#enable_ap_dhcp").attr("checked", wifisettings.dhcp_enable == 1);
	$("#hide_ssid").attr("checked", wifisettings.hide_ssid == 1);
	$("#ap_mac").val(wifisettings.ap_mac);
	$("#ap_ssid").val(wifisettings.ap_ssid);
	$("#ap_channel").val(wifisettings.ap_channel);
	$("#op_security").val(wifisettings.ap_security);
	$("#ap_password").val(wifisettings.ap_password);	
	$("#rp_password").val(wifisettings.ap_password);
	$("#select_country_region").val(wifisettings.countryregion);
	//if(getCookieLanguage()=="cn")
	{
	   $("#button_wifi_settings_update").val(eval('button_res.'+getCookieLanguage()+'["Apply"]'));
	   $("#btnWifiScan").val(eval('button_res.'+getCookieLanguage()+'["Wireless Scan"]'));
	   $("#btn_update_ip").val(eval('button_res.'+getCookieLanguage()+'["Update IP"]'));
	   $("#button_apply_settings").val(eval('button_res.'+getCookieLanguage()+'["Connect"]'));	   
	   $("#button_ethernet_settings_update").val(eval('button_res.'+getCookieLanguage()+'["Apply"]'));
	   $("#button_help").val(eval('button_res.'+getCookieLanguage()+'["Help Right"]'));
	   $("#btnOther").val(eval('button_res.'+getCookieLanguage()+'["Other"]'));
	   $("#btnOtherConnect").val(eval('button_res.'+getCookieLanguage()+'["Connect"]'));
	}
	
	//client	
	$("#spanWifiSsid").html(wifisettings.cli_ssid);		
	$("#spanWifiSecurity").html(wifisettings.wifisettingsSecurityEncryption[wifisettings.cli_security]);
	$("#other_ssid").val(wifisettings.cli_ssid);
	$("#other_security").val(wifisettings.cli_security.toString());	
	
    $("#op_ipmode").val(wifisettings.cli_ipmode);

	if( wifisettings.cli_ipmode == 0 )
	{
		if(wifisettings.cli_ipaddress != "")
		{
	       var ips = wifisettings.cli_ipaddress.split(".");
		   for(var i=0;i<4;i++) 
		   	   $("#ip"+i).val(ips[i]);
		}
		
		if(wifisettings.cli_netmask != "")
		{
	      var netmasks = wifisettings.cli_netmask.split(".");
		  for(var i=0;i<4;i++)
		   	  $("#netmask"+i).val(netmasks[i]);
		}

		if(wifisettings.cli_gateway != "")
		{
	      var gateways = wifisettings.cli_gateway.split(".");
		  for(var i=0;i<4;i++)
		   	  $("#gateway"+i).val(gateways[i]);
		}
	}
}
