var httplive = {};
httplive.enable = 0;
httplive.windowSize = "";
httplive.segmentDuration = "";

httplive.MIN_WINDOW_SIZE = 3;
httplive.MAX_WINDOW_SIZE = 4;
httplive.MIN_SEGMENT_DURATION = 1;
httplive.MAX_SEGMENT_DURATION = 10;

httplive.numStreams = 0;
httplive.streamlocations = new Array();
httplive.streamnames = new Array();
httplive.vencoder = new Array();

httplive.ResponseCodes = {
		"SUCCESS" : 0,
		"UNSUPPORTED_HTTP_METHOD" : 1,
		"UNSUPPORTED_RETURN_TYPE" : 2,
		"UNSUPPORTED_ATTRIBUTE" : 3,
		"UNKNOWN_ATTRIBUTE" : 4,
		"UNKNOWN_PROPERTY" : 5,
		"MESSAGE_PARSE_ERROR" : 6,
		"DATABASE_FAILURE" : 7,
		"UNKNOWN_ERROR" : 8,
		"INVALID_WINDOW_SIZE" : 9,
		"INVALID_BOOLEAN_ENABLE" : 10,
		"INVALID_STREAM_FORMAT" : 11,
		"INVALID_SEGMENT_DURATION" : 12,
		"FAILED_TO_RESTART_STREAMING" : 13
	};

httplive.ResponseStrings = ["Success",
                           "Incorrect http method for this resource",
                           "Unsupported return mime-type",
                           "Unsupported attribute encountered for this resource",
                           "Unknown attribute encountered for this resource",
                           "Unknown property encountered for this resource",
                           "Message parsing error",
                           "Database IO error",
                           "An unknown error was encountered",
                           "Window size is invalid",
                           "Invalid boolean set to toggle httplive streaming",
                           "Invalid stream format encountered",
                           "Segment duration is invalid",
                           "Failed to restart streaming"];

httplive.get = function(instance) {
	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
		},
		url: "/cgi-bin/v1/servers/httplive"+((instance == undefined)?"?":"/"+instance+"?")+Math.random(),
		async: false,
		type: "GET",
		dataType: "xml",
		success: getSuccessHandler,
		error: function(err, textStatus) {
			handleError("/servers/httplive", "GET", err, textStatus);
		}
	});
	
	function getSuccessHandler (result) {
		var serverNode = $(result).children("servers");
		
		var httpliveNode = $(serverNode).children("httplive");
		
		if (instance == undefined) {
			// get on /servers/httplive
			var streamsNode = $(httpliveNode).children("streams");
			httplive.numStreams = parseInt(streamsNode.attr("num"));
			$(streamsNode).find("stream").each(function(){
				var instance = parseInt($(this).attr("instance"));
				var location = parseInt($(this).attr("location"));
				// unescape
				location = unescape(location);
				httplive.streamlocations[instance] = location;
			});
			
			var windowSizeNode = $(httpliveNode).children("windowSize");
			if (windowSizeNode == undefined || windowSizeNode.attr("ul") == undefined) {
				alert("Window size missing");
				return;
			} else {
				httplive.windowSize = parseInt (windowSizeNode.attr("ul"));
			}
			
			var segmentDurationNode = $(httpliveNode).children("segmentDuration");
			if (segmentDurationNode == undefined || segmentDurationNode.attr("ul") == undefined) {
				alert("Segment duration missing");
				return;
			} else {
				httplive.segmentDuration = parseInt (segmentDurationNode.attr("ul"));
			}
			
			var enabledNode = $(httpliveNode).children("enable");
			if (enabledNode == undefined || enabledNode.attr("b") == undefined) {
				alert("httplive <enable b=\"\"/> node missing");
				return;
			} else {
				httplive.enable = parseInt(enabledNode.attr("b"));
			}
		} else {
			// get on /servers/httplive/{n}
			var streamNode = $(httpliveNode).children("stream");
			var sname = $(streamNode).find("sname").attr("s");
			var vencoder = $(streamNode).find("vencoder").attr("s");
			// unescape
			sname = unescape(sname);
			vencoder = unescape(vencoder);
			httplive.streamnames[instance] = sname;
			//alert("sname:"+sname );
			var encoderinstance = vencoder.substr(vencoder.lastIndexOf("/")+1);
			httplive.vencoder[instance] = encoderinstance;
			//avc.get(encoderinstance);
		}
	}
};

httplive.put = function () {
	function serializeXML () {
		var enable = $("#checkbox_httplive_enable").attr("checked") ? 1:0;
		var windowSize = $("#txt_window_size").val();
		var segmentDuration = $("#txt_segment_duration").val();

		var xml = '<?xml version="1.0"?>';
		xml += '<servers>';
		xml += '<httplive>';
		xml += '<enable b="'+enable+'"/>';
		xml += '<windowSize ul="'+windowSize+'"/>';
		xml += '<segmentDuration ul="'+segmentDuration+'"/>';
		xml += '</httplive>';
		xml += '</servers>';
		return xml;
	}
	
	var xml = serializeXML();
	
	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
			xhrObj.setRequestHeader("Content-Type","application/xml");
			$("#button_httplive").attr("disabled",true);
			$("#statusTxtHttpLive").html("Updating httplive stream settings...");
		    $("#spanLoaderHttplive").css({visibility:"visible"});
		},
		url: "/cgi-bin/v1/servers/httplive",
		type: "PUT",
		data: xml,
		dataType: "xml",
		success: putSuccessHandler,
		error: function(err, textStatus) {
			$("#spanLoaderHttplive").css({visibility:"hidden"});
			$("#button_httplive").attr("disabled",false);
			handleError("/servers/httplive", "PUT", err, textStatus);
		}
	});
	
	function putSuccessHandler (result) {
		// Check success
		var serverNode = $(result).children("servers");
		var res = $(serverNode).children("res").attr("ul");
		if( res != 0 ) {
			alert("Error! " + httplive.ResponseStrings[res]);
			$("#spanLoaderHttplive").css({visibility:"hidden"});
			$("#button_httplive").attr("disabled",false);
			return;
		}
		
		if (parseInt(currentStreamingMode) == parseInt(servers.StreamingModes.RTP)) {
			cameraStatus.cameraOnHandler = httplive.cameraOn;
			$("#statusTxtHttpLive").html("Please wait while your video streaming restarts...");
			//statusTimer = window.setTimeout(cameraStatus.get, 2000);
		} else {
			httplive.cameraOn();
		}
	}
};

httplive.cameraOn = function () {
	$("#button_httplive").attr("disabled",false);
	$("#spanLoaderHttplive").css({visibility:"hidden"});
	alert("Httplive stream settings updated");
};

httplive.setValues = function () {
	$("#checkbox_httplive_enable").attr("checked", (httplive.enable == 1));
	$("#txt_window_size").val(httplive.windowSize);
	$("#txt_segment_duration").val(httplive.segmentDuration);
};

httplive.getAll = function () {
	httplive.get();
	for(var i = 0; i < httplive.numStreams; i++) {
		httplive.get(i);
	}
};
