var rtmp = {};
rtmp.numStreams = 0;
rtmp.streamlocations = new Array();
rtmp.streamnames = new Array();

rtmp.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8
};

rtmp.ResponseStrings = ["Success",
                       "Incorrect http method for this resource",
                       "Unsupported return mime-type",
                       "Unsupported attribute encountered for this resource",
                       "Unknown attribute encountered for this resource",
                       "Unknown property encountered for this resource",
                       "Message parsing error",
                       "Database IO error",
                       "An unknown error was encountered"];

rtmp.get = function(instance) {
	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
		},
		url: "/cgi-bin/v1/servers/rtmp"+((instance == undefined)?"?":"/"+instance+"?")+Math.random(),
		async: false,
		type: "GET",
		dataType: "xml",
		success: getSuccessHandler,
		error: function(err, textStatus) {
			handleError("/servers/rtmp", "GET", err, textStatus);
		}
	});
	
	function getSuccessHandler (result) {
		var serverNode = $(result).children("servers");
		
		var rtmpNode = $(serverNode).children("rtmp");
		
		if (instance == undefined) {
			// get on /servers/rtmp
			var streamsNode = $(rtmpNode).children("streams");
			rtmp.numStreams = parseInt(streamsNode.attr("num"));
			$(streamsNode).find("stream").each(function(){
				var instance = parseInt($(this).attr("instance"));
				var location = parseInt($(this).attr("location"));
				// unescape
				location = unescape(location);
				rtmp.streamlocations[instance] = location;
			});
		} else {
			// get on /servers/rtmp/{n}
			var streamNode = $(rtmpNode).children("stream");
			var sname = $(streamNode).find("sname").attr("s");
			// unescape
			sname = unescape(sname);
			rtmp.streamnames[instance] = sname;
		}
	}
};

rtmp.getAll = function () {
	rtmp.get();
	for(var i = 0; i < rtmp.numStreams; i++) {
		rtmp.get(i);
	}
};
