var rtsp = {};
rtsp.port = 0;
rtsp.numStreams = 0;
rtsp.streamlocations = new Array();
rtsp.streamnames = new Array();
rtsp.vencoders = new Array();

rtsp.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8
};

rtsp.ResponseStrings = ["Success",
                       "Incorrect http method for this resource",
                       "Unsupported return mime-type",
                       "Unsupported attribute encountered for this resource",
                       "Unknown attribute encountered for this resource",
                       "Unknown property encountered for this resource",
                       "Message parsing error",
                       "Database IO error",
                       "An unknown error was encountered"];

rtsp.get = function(instance) {
	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
		},
		url: "/cgi-bin/v1/servers/rtsp"+((instance == undefined)?"?":"/"+instance+"?")+Math.random(),
		async: false,
		type: "GET",
		dataType: "xml",
		success: getSuccessHandler,
		error: function(err, textStatus) {
			handleError("/servers/rtsp", "GET", err, textStatus);
		}
	});
	
	function getSuccessHandler (result) {
		var serverNode = $(result).children("servers");
		
		var rtspNode = $(serverNode).children("rtsp");
		
		if (instance == undefined) {
			// get on /servers/httplive
			rtsp.port = parseInt($(rtspNode).children("port").attr("ul"));
			var streamsNode = $(rtspNode).children("streams");
			rtsp.numStreams = parseInt(streamsNode.attr("num"));
			$(streamsNode).find("stream").each(function(){
				var instance = parseInt($(this).attr("instance"));
				var location = parseInt($(this).attr("location"));
				// unescape
				location = unescape(location);
				rtsp.streamlocations[instance] = location;
			});
		} else {
			// get on /servers/rtsp/{n}
			var streamNode = $(rtspNode).children("stream");
			var sname = $(streamNode).find("sname").attr("s");
			// unescape
			sname = unescape(sname);
			rtsp.streamnames[instance] = sname;
			var vencoder = $(streamNode).find("vencoder").attr("s");
			// unescape
			vencoder = unescape(vencoder);
			rtsp.streamnames[instance] = sname;
			var encoderinstance = vencoder.substr(vencoder.lastIndexOf("/")+1);
			rtsp.vencoders[instance] = encoderinstance;
		}
	}
};

rtsp.getAll = function () {
	rtsp.get();
	for(var i = 0; i < rtsp.numStreams; i++) {
		rtsp.get(i);
	}
};
