var memcardlist = {};
memcardlist.list = {};
memcardlist.currentFolder = "/";
memcardlist.prevFolder = memcardlist.currentFolder;
memcardlist.currentId = '';

memcardlist.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8,
	"MEMCARD_NOT_DETECTED" : 9,
	"FOLDER_NOT_FOUND" : 10
};

memcardlist.ResponseStrings = ["Success",
                                 "Incorrect http method for this resource",
                                 "Unsupported return mime-type",
                                 "Unsupported attribute encountered for this resource",
                                 "Unknown attribute encountered for this resource",
                                 "Unknown property encountered for this resource",
                                 "Message parsing error",
                                 "Database IO error",
                                 "An unknown error was encountered",
                                 "Memory card not detected",
                                 "Folder not found"];


memcardlist.ACTIONS = {
	"MOVE" : 0,
	"RENAME" : 1,
	"DELETE" : 2,
	"VIEW" : 3
};

memcardlist.get = function(folder) {
	memcardlist.prevFolder = memcardlist.currentFolder;
	memcardlist.currentFolder = (folder==undefined)?"/":folder;
	folder = (folder==undefined)?"":folder;
	
	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
		},
		url: "/cgi-bin/v1/storage/memcard/list/"+folder+"?"+Math.random(),
		type: "GET",
		async: false,
		dataType: "xml",
		success: getSuccessHandler,
		error: function(err, textStatus) {
			handleError("/storage/memcard/list/"+folder, "GET", err, textStatus);
		}
	});
	
	function getSuccessHandler( result ) {
		var storageNode = $(result).children("storage");
		
		var res = $(storageNode).children("res").attr("ul");
		if(res == undefined) {
			//alert("result not set");
			return;
		} else {
			if( parseInt(res) != memcardlist.ResponseCodes.SUCCESS ) {
				//alert("Error: "+memcardlist.ResponseStrings[parseInt( res )]);
				return;
			}
		}
		
		var memcardNode = $(storageNode).children("memcard");
		var listNode = $(memcardNode).children("list");

		var id = 0;
		var table = '<table width="100%" style="border:solid 1px;">';
		table += "<tr>";		
		table += "<td colspan='4'><a href=\"#\" onclick=\"memcardlist.back()\" style=\"color:blue;text-decoration:underline;\">";
		table +=eval('button_res.'+getCookieLanguage()+'["Back"]')+"</a>&nbsp;&nbsp;<a href=\"#\" onclick=\"memcardlist.up()\" style=\"color:blue;text-decoration:underline;\">";
		table +=eval('button_res.'+getCookieLanguage()+'["Up"]')+"</a></th>";
		table += "</tr>";
		table += "<tr>";
		
		{
		  table += "<th>"+eval('option_res.'+getCookieLanguage()+'["Name"]')+"</th>";
		  ///table += "<th>Type</th>";
		  table += "<th>"+eval('option_res.'+getCookieLanguage()+'["Size"]')+"</th>";
		  table += "<th colspan='2' style='text-align:center;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"+eval('option_res.'+getCookieLanguage()+'["Action"]')+"</th>";
		}
		
		table += "</tr>";
		var myhref;
		$(listNode).find("file").each(function() {
			var name = html_entity_decode($(this).children("name").attr("s"));
			var type = parseInt($(this).children("type").attr("ul"));
			var size = parseInt($(this).children("size").attr("ul")/10000);
			var tid = "tr"+id;
			var divid = "div"+id;			
			table += '<tr>';
			var aname = name;
			///if (type == 0) {
			///	aname = "<a href='#' onclick=\"memcardlist.dirClick("+id+")\" style=\"color:blue;text-decoration:underline;\">"+name+"/</a>";
			///}
			table += '<td>'+aname+'</td>';
			///type = (type == 1) ? "File" : "Directory";
			///table += '<td>'+type+'</td>';
			///if (type == "File") {
			///	table += "<td><a href=\"#\" onclick=\"memcardlist.performAction("+memcardlist.ACTIONS.VIEW+",'"+id+"')\" style=\"color:blue;text-decoration:underline;\">View</a></td>";
			///} else {
			///	table += "<td style='text-align:center;'>-</td>";
			///}
			
			if(type == 1)
		    {	
		       table += '<td>'+size/100+"M"+'</td>';
			   if (location.port && location.port != 80)
			   	 myhref = "http://"+location.hostname+ ":" + location.port+"/"+memcardFolder+"/"+memcardlist.currentFolder+"/"+name;
			   else
			     myhref = "http://"+location.hostname+"/"+memcardFolder+"/"+memcardlist.currentFolder+"/"+name;
		       table += "<td colspan='2' style='text-align:center;'><a href=\"";
			   table +=	myhref;
			   table += "\" onclick=\"memcardlist.performAction("+memcardlist.ACTIONS.VIEW+",'"+id+"')\" style=\"color:blue;text-decoration:underline;\">";
			   table +=	eval('button_res.'+getCookieLanguage()+'["View"]')+"</a></td>";
			   //table += "<td><a href=\"#\" onclick=\"memcardlist.performAction("+memcardlist.ACTIONS.VIEW+",'"+id+"')\" style=\"color:blue;text-decoration:underline;\">鿴</a></td>";
			   //table += "<td><a href=\"#\" onclick=\"memcardlist.performAction("+memcardlist.ACTIONS.MOVE+",'"+id+"')\" style=\"color:blue;text-decoration:underline;\">Move</a></td>";
			   //table += "<td><a href=\"#\" onclick=\"memcardlist.performAction("+memcardlist.ACTIONS.RENAME+",'"+id+"')\" style=\"color:blue;text-decoration:underline;\">Rename</a></td>";
			   //table += "<td><a href=\"#\" onclick=\"memcardlist.performAction("+memcardlist.ACTIONS.DELETE+",'"+id+"')\" style=\"color:blue;text-decoration:underline;\">ɾ</a></td>";
			}	
			else
			{
              table += "<td>&nbsp;&nbsp;-</td>";
			  table += "<td colspan='2' style='text-align:center;'><a href='#'";
			  table += " onclick=\"memcardlist.dirClick("+id+")\" style=\"color:blue;text-decoration:underline;\">";
			  table +=	eval('button_res.'+getCookieLanguage()+'["View"]')+"</a></td>";
			}
			table += "</tr>";
			table += '<tr id="'+tid+'" style="display:none;">';
			table += "<td colspan='3'><div id='"+divid+"'></div></td>";
			table += "</tr>";
			
			//memcardlist.list[id]={"name":name,"type":type};
			memcardlist.list[id]={"name":name,"size":size};
			id++;
		});
		table += "</table>";
		
		//document.getElementById("icontent").src = "";
		memcardlist.prevtid = "";
		$("#divAction").appendTo($("#movableDivContainer")).hide();
		$("#divMemCardContents").html(table);
	}
};

memcardlist.move = function () {
	memcard.put(memcardlist.ACTIONS.MOVE,memcardlist.currentId);
};

memcardlist.rename = function () {
	memcard.put(memcardlist.ACTIONS.RENAME,memcardlist.currentId);
};

memcardlist.del = function () {
	memcard.put(memcardlist.ACTIONS.DELETE,memcardlist.currentId);
};

memcardlist.up = function () {
	if(memcardlist.currentFolder != "/")
	{
	  var updir = memcardlist.currentFolder.substr(0, memcardlist.currentFolder.lastIndexOf("/"));
	  if(updir == "") updir ="/";	
	  $("#selectList").val(updir);
	  list();
	}
};

memcardlist.back = function() {
	$("#selectList").val(memcardlist.prevFolder);
	list();
};

memcardlist.dirClick = function(id) {
	memcardlist.currentId = id;
	var filedata = memcardlist.list[id];
	filename = memcardlist.currentFolder;
	if (filename != rootFolder)
	{
		filename += "/";
	}
	filename += filedata.name;
	$("#selectList").val(filename);
	list();
};

memcardlist.prevtid = "";
memcardlist.performAction = function (action,id) {
	memcardlist.currentId = id;
	var tid = "tr"+id;
	var divid = "div"+id;
	
	var showTr = false;
	var filedata = memcardlist.list[id];
	
	switch(parseInt(action)) {
	case memcardlist.ACTIONS.MOVE:
		$("#trDirList").show();
		$("#trNewFileName").hide();
		$("#trIFrame").hide();
		showTr = true;
		break;
	case memcardlist.ACTIONS.RENAME:
		$("#txtNewFileName").val(filedata.name);
		$("#trDirList").hide();
		$("#trNewFileName").show();
		$("#trIFrame").hide();
		showTr = true;
		break;
	case memcardlist.ACTIONS.DELETE:
		answer = confirm("Are you sure?");
		if (answer) {
			memcardlist.del();
		}
		break;
	case memcardlist.ACTIONS.VIEW:
		$("#trDirList").hide();
		$("#trNewFileName").hide();

		//document.getElementById("icontent").src = "http://"+location.hostname+"/"+memcardFolder+"/"+memcardlist.currentFolder+"/"+filedata.name;
		//alert(document.getElementById("icontent").src);
		//$("#trIFrame").show();
		showTr = false;
		break;
	}
	
	
	if (memcardlist.prevtid != tid)
	{
		if(memcardlist.prevtid.length > 0) 
		{
			$("#"+memcardlist.prevtid).hide();
		}
		
		memcardlist.prevtid = tid;

		if (!showTr) {
		return;
	    }
		
		$("#"+tid).fadeIn("slow");
		$("#divAction").appendTo($("#"+divid)).show();
	}
};
