var wifireset = {};

wifireset.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8
};

wifireset.ResponseStrings = ["Success",
                             "Incorrect http method for this resource",
                             "Unsupported return mime-type",
                             "Unsupported attribute encountered for this resource",
                             "Unknown attribute encountered for this resource",
                             "Unknown property encountered for this resource",
                           	 "Message parsing error",
                           	 "Database IO error",
                           	 "An unknown error was encountered"];

wifireset.put = function () {
	xml = "";
	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
			$("#button_wifi").attr("disabled", true);
			$("#spanLoaderWifi").css({visibility:"visible"});
		},
		url: "/cgi-bin/v1/system/reset/wifi",
		type: "PUT",
		data: xml,
		dataType: "xml",
		async: false,
		success: putSuccessHandler,
		error: function(err, textStatus) {
			$("#button_wifi").attr("disabled", false);
			$("#spanLoaderWifi").css({visibility:"hidden"});
			handleError("/system/reset/wifi", "PUT", err, textStatus);
		}
	});

	function putSuccessHandler (xml) {
		$("#button_wifi").attr("disabled", false);
		$("#spanLoaderWifi").css({visibility:"hidden"});
		var systemNode = $(xml).children("system");

		var res = $(systemNode).children("res").attr("ul");
		if (res == undefined) {
			alert("res not set");
			return;
		} else if (parseInt(res) != wifireset.ResponseCodes.SUCCESS) {
			alert("Error! " + wifireset.ResponseStrings[parseInt(res)]);
			return;
		}
		
		alert ("Your Camera's wifi configuration settings have been reset to its factory default!\nYour Camera is being rebooted. Please connect to your camera in Adhoc mode once it has booted.");
	}
};
