var produce = {};
produce.language = 'en';
produce.type = '0';
produce.lan = '0';
produce.vtype = 0;
produce.osd = '0';
produce.g3id = '';

produce.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8
};

produce.ResponseStrings = ["Success",
                                "Incorrect http method for this resource",
                                "Unsupported return mime-type",
                                "Unsupported attribute encountered for this resource",
                                "Unknown attribute encountered for this resource",
                                "Unknown property encountered for this resource",
                           	  	"Message parsing error",
                           	  	"Database IO error",
                           	  	"An unknown error was encountered"];

produce.get = function() {
	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");
		},
		url: "/cgi-bin/v1/system/settings/produce?"+Math.random(),
		async: false,
		type: "GET",
		dataType: "xml",
		success: getSuccessHandler,
		error: function(err, textStatus) {
			handleError("/settings/produce", "GET", err, textStatus);
		}
	});
	
	function getSuccessHandler (result) {
		var rootNode = $(result).children("produce");
		var res = $(rootNode).children("res").attr("ul");

		if (res == undefined) {
			//alert("result not set");
			return;
		} 
		else 
		{
			if (parseInt(res) != produce.ResponseCodes.SUCCESS) {
				return;
			} 
			else 
			{
			    var valNode = $(rootNode).children("language");
				if (valNode != undefined && valNode.attr("s") != undefined)				
				{
					produce.language = valNode.attr("s");
				}

				valNode = $(rootNode).children("osd");
				if (valNode != undefined && valNode.attr("ul") != undefined)				
				{
					produce.osd = valNode.attr("ul");
				}
				
				valNode = $(rootNode).children("type");
				if (valNode != undefined && valNode.attr("ul") != undefined)				
				{
					produce.vtype = parseInt(valNode.attr("ul"),10);
					produce.type = (produce.vtype&0x1).toString();
					produce.lan = (produce.vtype>>4&0x1).toString();
				}

				valNode = $(rootNode).children("g3id");
				if (valNode != undefined && valNode.attr("s") != undefined)				
				{
					produce.g3id = valNode.attr("s");
				}
			}
		}
		
	}
	
};

produce.put = function () {
	function serializeXML() {				

        var xml = '<?xml version="1.0"?>\r\n';
		xml += '<produce>';	
		xml += '<language s="' + $("#opt_language").val() + '"/>';
		xml += '<osd ul="' + $("#opt_osd").val() + '"/>';
		produce.vtype = parseInt($("#opt_lan").val(),10);
		produce.vtype = (produce.vtype<<4)|parseInt($("#opt_type").val(),10);
		xml += '<type ul="' + produce.vtype + '"/>';
		xml += '<g3id s="' + $("#txt_number").val() + '"/>';
		xml += '<mac s="' + $("#txt_mac6").val() + $("#txt_mac5").val() + '"/>';		
		
		xml += '</produce>';

		return xml;
	}

	var xml = serializeXML();
	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept", "application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");
			$("#button_apply").attr("disabled", true);
			//$("#tip_mac").css({visibility:"visible"});
			$("#tip_mac").html("òƷ...");
		},
		url: "/cgi-bin/v1/system/settings/produce",
		type: "PUT",
		data: xml,
		dataType: "xml",
		async: true,
		success: putSuccessHandler,
		error: function(err, textStatus) {
			$("#button_apply").attr("disabled", false);
			$("#tip_mac").css({visibility:"hidden"});
		}
	});

	function putSuccessHandler (xml) {
		$("#button_apply").attr("disabled", false);
		var systemNode = $(xml).children("produce");

		var res = $(systemNode).children("res").attr("ul");
		if (res == undefined) {
			//alert("res not set");
			return;
		} 
		else if (parseInt(res) != produce.ResponseCodes.SUCCESS)
		{
		    $("#tip_mac").html("Ʒʧ");
		}
		else
		{
			
			$("#tip_mac").html("Ʒóɹ");
			set_cachedvalue();
		}	
		
		//alert ("All your camera's configuration settings have been reset to their factory defaults!\nYour Camera is being rebooted. Please connect to your camera in Adhoc mode once it has booted.");
	}
};
