var browser;

// used to distinguish between IE and other browsers
var IE = false;

var ipaddress;
var port = "554";

// Holds the currently playing stream type
// image, localVideo, remoteVideo
var StreamType = {
	"jpeg":0,
	"video":1,
	"quicktime":2
};

var CameraType = {
	"live":0,
	"setting":1
};

var StreamingModes = {
	"RTP":0,
	"RTMP":1
};

var currentStreamType = StreamType.video;
var currentStreamingMode = StreamingModes.RTP;
var currentCameraType = CameraType.live;

/**
 * @brief Remove any currently playing stream
 */
function removeStream() {
	clearImageTimer();
	if( IE )
	{
		try 
		{   
		    var vlc = document.getElementById("vlc");
			// playlist object only works with IE vlc plugin
			vlc.playlist.stop();
		}
		catch(e) {}
	}
	
	$("#vlccontent").html("");
	$("#httplivecontent").html("");
	$("#flashcontent").html("");
	$("#imagecontent").html("");	
}

function playstream(stream, cam_select, cam_mode)	{
	//var streamtitle = "";
	var agent = navigator.userAgent.toLowerCase();
    var is_iphone = (agent.indexOf('iphone') !=-1);
    var is_ipod = (agent.indexOf('ipod') !=-1);
    var is_ipad = (agent.indexOf('ipad') !=-1);
    var is_android = (agent.indexOf('android') !=-1);	
	
    if (stream == undefined) {
    	stream = 0;
    }
	
    if (cam_select == undefined)
    {
        cam_select = 4;
	}
	
	if (cam_mode == undefined)
    {
        cam_mode = CameraType.live;
	}
	currentCameraType = cam_mode;
	
    var streamname = "";
	var width = 640, height = 360;
	//if(((!is_iphone && !is_ipod && !is_android) || 4 == cam_select) && (currentCameraType == CameraType.live))	
	if( (!is_iphone && !is_ipod && !is_android) && (currentCameraType == CameraType.live) )	
	{
       width *= 2;
	   height *= 2;
	}
	//alert("width="+width);
//	var remote_resolution = avc.resolutions[1];
//	var local_resolution = avc.resolutions[0];
	
//	width = servers.STREAM_WIDTH_X_HEIGHT[avc.resolutions[stream]].width;
//	height = servers.STREAM_WIDTH_X_HEIGHT[avc.resolutions[stream]].height;
	
	if (width > 1280) {
        // Display stream of atmost 1280px
		ratio = height/width;
		width = 1280;
		height = width * ratio;
	}
	removeStream();

	//var httpPath = "http://" + ipaddress + "/";
	var httpPath = "http://" + ipaddress;
	if (location.port && location.port != 80) {
		httpPath += ":" + location.port;
	} else {
		httpPath += "/";
	}
	
	if (currentStreamType == StreamType.jpeg) {
		///streamtitle = "Image Stream " + stream;
		//streamname = snapshot.streamnames[stream];
		//width = servers.STREAM_WIDTH_X_HEIGHT[avc.resolutions[snapshot.vencoders[stream]]].width;
		//height = servers.STREAM_WIDTH_X_HEIGHT[avc.resolutions[snapshot.vencoders[stream]]].height;
		embedJPEG(httpPath, width, height, cam_select,cam_mode);
	} 
/*
	else if (currentStreamType == StreamType.video) {
		if ((is_iphone) || (is_ipod) || (is_ipad)) {
			width = servers.STREAM_WIDTH_X_HEIGHT[avc.resolutions[httplive.vencoders[stream]]].width;
			height = servers.STREAM_WIDTH_X_HEIGHT[avc.resolutions[httplive.vencoders[stream]]].height;
		} else {
			width = servers.STREAM_WIDTH_X_HEIGHT[avc.resolutions[rtsp.vencoders[stream]]].width;
			height = servers.STREAM_WIDTH_X_HEIGHT[avc.resolutions[rtsp.vencoders[stream]]].height;
		}
	}
*/
    ///alert("width="+width.toString());
	//$("#main").width(
	//		(parseInt(width) < 640 ? 640 : parseInt(width)) + 20 + "px");
    //if(currentCameraType == CameraType.live)
    //{
	//	$("#content-wrapper").width((parseInt(width) < 640 ? 640 : parseInt(width)) + 20 + "px");
    //}

    //alert("ipaddress is "+ipaddress.toString());
	if (!ipaddress.length) {
		alert("Please enter Ipaddress");
		return;
	}

	var rtspPath;
	
	rtspPath = "rtsp://" + ipaddress + ":" + port + "/";

	var rtmpPath = "rtmp://" + ipaddress;
	if (location.port && location.port != 80) {
		rtmpPath += ":" + location.port + "/live/";
	} else {
		rtmpPath += "/live/";
	}

	if (currentStreamType == StreamType.video) {
		if ((is_iphone) || (is_ipod) || (is_ipad) ) {
			//streamtitle = "HttpLive Stream " + stream;
			//streamname = httplive.streamnames[stream];
			//embedHttpLive(streamname, width, height);
			//streamname = snapshot.streamnames[stream];
			//width = 320;
			//height= 176;
			//streamname="/maxim/stream1.m3u8";
			//embedHttpLive(streamname, width, height);
			embedJPEG(httpPath, width, height, cam_select,cam_mode);
		} 
		else if(is_android)
		{
		    embedJPEG(httpPath, width, height, cam_select,cam_mode);
		}
		else		{						

			if (currentStreamingMode == StreamingModes.RTMP) 
			{
				embedFlash(rtmpPath, width, height);
			} 
			else 
			{
				if (is_android)
				{
					document.location = rtspPath + stream;
				} 
				else 
				{				   
					//embedVLC(rtspPath + streamname, width, height,cam);
					embedVLC(rtspPath, width, height,cam_select,cam_mode);
				}
			}
		}
	}
	else if (currentStreamType == StreamType.quicktime)
	{

	}
	// Set the stream title
	//$("#streamtitle").html('<label>'+streamtitle+'</label><br/>');
}

